static char *cvs_id =" $Id: bm_pks.c,v 1.2 2004/09/23 06:31:01 berar Exp $ ";
/*  xy_pks : image princeton (Winview ) et autres    */
/*  jfberar   berar@esrf.fr */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/

#include "xy_def.h"

#include "bm_def.h"

#include "7c_def.h"

/*-----------------------------------------------------------*/
typedef struct 
{   long xl, xh, yl, yh;
    int n, nbg, alloc, bgalloc;
    double sum, sbg;
    double x, y;
    PIXEL *pixel, *bgpixel;
    } PEAK;
/*-----------------------------------------------------------*/
void explore_peak (long x, long y, long zo, FLOAT64 *val, PEAK *pk, long dx, long dy);
/*-----------------------------------------------------------*/
void peaks(char *name, char *path, IMAGE *img)
{   int p, n, xl, xh, yl, yh, nbg, nsum;
    long i, ip, x, y, ihkl;
    long maxi;
    double sum, sumc;
    double bg;
    FILE *f_out;
    char *c, b[200], *cr;
    int a_peak, n_peak = 0;
    int m_peak = 5;
    float v_peak = 1.5;
    float o_peak = 0;
    PEAK *peak, *pk;
    FLOAT64 *val;
    
    cr = "\n";
    if (img->data.i == NULL &&  img->data.f == NULL) V_ERROR("no data to write");
    val=xy_needsfloat(img);
    if (val == NULL) V_ERROR("no data to write");
    while (*name == ' ' || *name == '=') name++;
    sscanf(name, "%d,%f,%f", &m_peak, &o_peak, &v_peak);
    if (m_peak <=0 ) m_peak=5;
    if (o_peak < 0 ) o_peak=0;
    if (v_peak < 1 ) v_peak=1.5;
    a_peak=2*m_peak;
    peak = (PEAK *) malloc(a_peak*sizeof(PEAK));
    if ( orig_x == 0.0) orig_x = image.x_size/2.0;
    if ( orig_y == 0.0) orig_y = image.y_size/2.0;
    
    if (path) 
    {   strcpy (b, path);    
        c = strrchr(b,'/');
        if ( !c || c - b != strlen(b)-1 ) strcat(b, "/");
        }
    else b[0]=0;
    c = strrchr(img->name,'/');
    if ( c )  c++; else c = img->name;
    strcat (b, c);
    c = strrchr(b, '/');
    if ( !c ) c = b;
    c = strrchr(c, '.');
    if ( c ) *c = 0;
    strcat (b, ".pks");
    
    printf ("# output %d peaks in %s (oscillation ampltude o_peak=%.2f, v_peak=%.2f)\n", m_peak, b, o_peak, v_peak);     
    printf(" UB %s\n", spec_ub == 1 ? "spec_mode(2Pi)" : "not_spec");
    for (i = 0; i < 9; i++) 
	 printf(" UB[%d]= %12.6lf %s", i, mat_ub.t[i], i%3==2?"\n":" ");
    inv_mat( & mat_inv_ub, &mat_ub );
    f_out = fopen(b, "w");
    printf ("# %s\n    px     py       max  sum-bg   wx wy    h      k      l    tth     chi\n", b);
    fprintf (f_out, "#  %s\n#   px     py       max    sum-bg  wx wy    h       k     l    tth     chi\n", b);
    p = 0;
    while (n_peak < m_peak)
    {  if ( p+1  >= a_peak ) 
       {    a_peak +=20;
            peak =(PEAK *) realloc(peak, a_peak*sizeof(PEAK));
            }
        pk = peak+p;
        maxi = val[0];
        ip = 0;
        for (i=1; i<image.size; i++) if( val[i] > maxi ) 
        {   maxi = val[i];
            ip = i;
            }  
        y = ip / image.x_size;
        x = ip % image.x_size;
        pk->xh=pk->xl=x;
        pk->yh=pk->yl=y;
        pk->sum=pk->sbg=0;
        pk->x = pk->y = 0;
        pk->n=pk->nbg=0;
        pk->pixel = (PIXEL*) malloc(50*sizeof(PIXEL));
        pk->bgpixel = (PIXEL*) malloc(50*sizeof(PIXEL));
        pk->alloc=pk->bgalloc=50;
        explore_peak (x, y, maxi, val, &peak[p], 0 ,0);
        nsum = pk->n;
        nbg = pk->nbg;
        { int ii, ij, ik, dx, dy;  /* correct included bg points */
          PIXEL *pixbg, *pix;
          for (n=0, pixbg=pk->bgpixel; n<pk->nbg; n++, pixbg++)
          {  ii = 0;
             for (ik=0, pix=pk->pixel; ik<pk->n; ik++, pix++)
             {  dx = pix->x - pixbg->x;
                dy = pix->y - pixbg->y;
                if( dy == 0 && (dx == 1 || dx == -1) ) ii++;
                if( dx == 0 && (dy == 1 || dy == -1) ) ii++;
                }
             for (ik=0, pix=pk->bgpixel; ik<pk->nbg; ik++, pix++)
             {  dx = pix->x - pixbg->x;
                dy = pix->y - pixbg->y;
                if( dy == 0 && (dx == 1 || dx == -1) ) ii++;
                if( dx == 0 && (dy == 1 || dy == -1) ) ii++;
                }
              if (ii >= 3)
              {  pk->sum += pixbg->z;
                 pk->x += pixbg->x * pixbg->z;
                 pk->y += pixbg->y * pixbg->z;
                 pk->sbg -= pixbg->z;
                 nsum++;
                 nbg--;
                 }
              }
           }
        pk->x /= pk->sum;
        pk->y /= pk->sum;
        if (nbg) bg = pk->sbg/(double)nbg ; else bg =0;
        sumc =  ( pk->sum > nsum*bg )? pk->sum - nsum * bg : pk->sum;
        if ( sumc >= v_peak * maxi )
        {   n_peak++;
            goniometer.pos.ry=(pk->x*image.x_obind+image.x_omin - orig_x)*scale_xx
                         +(pk->y*image.y_obind+image.y_omin - orig_y)*scale_xy;
            goniometer.pos.rz=(pk->x*image.x_obind+image.x_omin - orig_x)*scale_yx
                         +(pk->y*image.y_obind+image.y_omin - orig_y)*scale_yy;
            get_hkl();
            printf ( " %6.1lf %6.1lf %8d %8.0lf  %2d %2d %6.3lf %6.3lf %6.3lf", 
                pk->x, pk->y, maxi, sumc, 1+pk->xh-pk->xl, 1+pk->yh-pk->yl, hkl.hkl.v[0], hkl.hkl.v[1], hkl.hkl.v[2]);
            fprintf (f_out, " %6.1lf %6.1lf %8d %8.0lf  %2d %2d %6.3lf %6.3lf %6.3lf", 
               pk->x, pk->y, maxi, sumc, 1+pk->xh-pk->xl, 1+pk->yh-pk->yl, hkl.hkl.v[0], hkl.hkl.v[1], hkl.hkl.v[2]);
            if (hkl.ok != OK ) switch ( hkl.ok )
        {   case INVALID     : printf(" ERROR: invalid result\n"); fprintf (f_out, "ERROR: invalid result\n");return;
            case Q_RANGE     : printf(" ERROR: invalid q_range\n"); fprintf(f_out," ERROR: invalid q_range\n"); break;
            case DET_RANGE   : printf(" ERROR: invalid due to detector range\n"); fprintf(f_out," ERROR: invalid due to detector range\n"); break;
            case MODE_RANGE  : printf(" ERROR: invalid due to mode range\n"); fprintf(f_out," ERROR: invalid due to mode range\n"); break;
            }
        else
       {  hkl_cryst= hkl.hkl; 
          goniometer.pos.ry=0;
          goniometer.pos.rz=0;
          spec_mode=3;
          get_angles();
          printf(" %.4lf  %.4lf\n", hkl.bragg.pos.bragg, hkl.result.pos.chi  );
          fprintf(f_out, " %.4lf  %.4lf\n", hkl.bragg.pos.bragg, hkl.result.pos.chi  );
          }
       if (o_peak > 0) 
       {   double oth, o_err, err, derr;
           int i_osc, m_osc;
           double ho, ko, lo, oo, hi,ki,li;
           oth = goniometer.angle[1];
           o_err = 1.5; derr=0;
           for (i_osc= -20; i_osc<=20; i_osc++)
           {  goniometer.angle[1] = oth + i_osc * o_peak / 20.0;
            goniometer.pos.ry=(pk->x*image.x_obind+image.x_omin - orig_x)*scale_xx
                         +(pk->y*image.y_obind+image.y_omin - orig_y)*scale_xy;
            goniometer.pos.rz=(pk->x*image.x_obind+image.x_omin - orig_x)*scale_yx
                         +(pk->y*image.y_obind+image.y_omin - orig_y)*scale_yy;
            get_hkl();
            hi = fabs(hkl.hkl.v[0]);
            hi = hi - floor(hi);
            if (hi > 0.5 ) hi = 1-hi;
            ki = fabs(hkl.hkl.v[1]);
            ki = ki - floor(ki);
            if (ki > 0.5 ) ki = 1-ki;
            li = fabs(hkl.hkl.v[2]);
            li = li - floor(li);
            if (li > 0.5 ) li = 1-li;
            err = hi + ki + li;
            if ( err < o_err) 
            {   m_osc = i_osc;
                ho = hkl.hkl.v[0];
                ko = hkl.hkl.v[1];
                lo = hkl.hkl.v[2];
                oo = goniometer.angle[1];
                o_err = err;
                }
            else if ( o_err < 0.5 && err > o_err && derr > err) 
            {  printf ( "#HKL%23s %8.4lf    %6.3lf %6.3lf %6.3lf\n", " ", oo, ho, ko, lo);
               fprintf (f_out, "#HKL%23s %8.4lf    %6.3lf %6.3lf %6.3lf\n", " ", oo, ho, ko, lo);
               o_err = err;
               }
              derr = err; 
             }
            if ( o_err < 0.5 && derr > err) 
            {  printf ( "#HKL%23s %8.4lf    %6.3lf %6.3lf %6.3lf\n", " ", oo, ho, ko, lo);
               fprintf (f_out, "#HKL%23s %8.4lf    %6.3lf %6.3lf %6.3lf\n", " ", oo, ho, ko, lo);
               }
           goniometer.angle[1] = oth;
           }
       }
       p++;
       if (maxi == 0) { m_peak = n_peak; break; }
    }   
    a_peak = p;
   printf("\n %d peaks explored, %d only with  sumc >%.2f max\n", a_peak, m_peak, v_peak);
   fprintf(f_out, "\n %d peaks explored, %d only with  sumc >%.2f max\n", a_peak, m_peak, v_peak);
    for (p=0; p<a_peak; p++)
    {   pk = peak+p;
        for (n=0; n<pk->n; n++)
        {  i = pk->pixel[n].y * image.x_size + pk->pixel[n].x;
           val[i] = pk->pixel[n].z;
           }
        free(pk->pixel);   
        for (n=0; n<pk->nbg; n++)
        {  i = pk->bgpixel[n].y * image.x_size + pk->bgpixel[n].x;
           val[i] = pk->bgpixel[n].z;
           }
        free(pk->bgpixel);   
        }
   free(peak);     
   }
/*-----------------------------------------------------------*/
void explore_peak (long x, long y, long zo, FLOAT64 *val, PEAK *pk, long dx, long dy)
{    long i, z;
     PIXEL *pix;
     int n;
     i = y * image.x_size + x;
     z = val[i];
     if ( z <= 0 ) return;
     if ( z > zo) 
     {  if (dy == 0 || dy == 0) return;
        pk->nbg++;
        if (pk->nbg >= pk->bgalloc) 
        {   pk->bgalloc += 50;
            pk->bgpixel = (PIXEL *) realloc(pk->bgpixel, pk->bgalloc * sizeof(PIXEL));
            }
        pix=(pk->bgpixel)+pk->nbg-1;
        pix->x = x;
        pix->y = y;
        pk->sbg += pix->z = z;
        val[i]=0;
        return;
        }
     pk->n++;
     if (pk->n >= pk->alloc) 
     {   pk->alloc += 50;
         pk->pixel = (PIXEL *) realloc(pk->pixel, pk->alloc * sizeof(PIXEL));
         }
     pix=(pk->pixel)+pk->n-1;
     pix->x = x;
     pix->y = y;
     pk->sum += pix->z = z;
     val[i]=0;
     pk->x   += z*x;
     pk->y   += z*y;
     if ( x < pk->xl ) pk->xl=x;
     if ( y < pk->yl ) pk->yl=y;
     if ( x > pk->xh ) pk->xh=x;
     if ( y > pk->yh ) pk->yh=y;
     if ( x < image.x_size - 1 && dx >= 0)   explore_peak( x+1, y, z, val, pk, dx+1, dy);
     if ( y < image.y_size - 1 && dy >= 0)   explore_peak( x, y+1, z, val, pk, dx, dy+1);
     if ( x >= 1 && dx <= 0)  explore_peak( x-1, y, z, val, pk, dx-1, dy);
     if ( y >= 1 && dy <= 0)  explore_peak( x, y-1, z, val, pk, dx, dy-1);
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

