static char *cvs_id =" $Id: bm_rad.c,v 1.14 2005/03/22 09:15:38 berar Exp $ ";
/*  bm_rad : image princeton (Winview ) et autres    */
/*  jfberar   berar@esrf.fr     */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/

#include "xy_def.h"
#include "bm_def.h"
/* #include <values.h> cygwin pb*/
#ifndef MAXFLOAT
#define MAXFLOAT 1.e+35
#endif

extern char * f_name;
extern char * d_name;
extern char * g_name;
extern char * i_name;
/*-----------------------------------------------------------*/
/* used in specific external routines */
int   n_sector = 1;
int   rad_loop = 0;      
float a_sector = 1000.0;
float radius = 1.0;
float rad_min = -MAXFLOAT;      /* I do not know how to set -Inf on various machine */
float rad_max =  MAXFLOAT;    
float rad_off = 0;      
double rad_draw[]={0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0}; 
int   radial_drawn = 0;
int   rad_sector = 0;
int   rad_print = 0;
char *p_sector = NULL;
float rad_x_ang=0; 
float rad_y_ang=0; 
float rad_x_orig=0; 
float rad_y_orig=0; 
float rad_d_pixels=0; 
double rad_x_cos=1.0; 
double rad_y_cos=1.0; 
double rad_x_sin=0.0; 
double rad_y_sin=0.0; 
char *rad_x = NULL;
char *rad_y = NULL;
char *rad_dx = NULL;
char *rad_dy = NULL;
char *rad_exec = NULL;
double rad_loop_tol=6;        /* 6 sigma */
/*-----------------------------------------------------------*/
#define MAX_SECTORS 720
int   writen_lines=0;
char  rad_line[7+30*MAX_SECTORS];
int   valid_rad_line;
void  ini_rad_line(float r);
void  add_rad_line(double y, double z, double n_r);
void  add_rad_line_y(double y);
void  add_rad_line_z(double y);
void  add_rad_line_n(double y);
void  add_rad_line_space(void);
int   end_rad_line(FILE * f_out);
void  draw_radial(IMAGE *img, double center_x, double center_y);
/*-----------------------------------------------------------*/
double rad_hypot(double x, double y, double cx, double cy);
double rad_atan(double x, double y, double cx, double cy);
void ini_transfo_coord( char *name, int axe);
void end_transfo_coord( );
double transfo_coord( int axe, double x, double y);
double density_coord( int axe, double x, double y);
/*-----------------------------------------------------------*/
extern int   cr_mode;
/*-----------------------------------------------------------*/
void use_radial()
{
    fprintf(stderr, "  radial distribution is centered by ORIGIN key\n");
    fprintf(stderr, "    and the following group of dedicated keys\n");
    fprintf(stderr, " RADIUS   = radius binning\n");
    fprintf(stderr, " RAD_MAX  = if set upper limit value in radial distribution\n");
    fprintf(stderr, " RAD_OFF  = offset in radial distribution (0 if not set) and lower limit\n");
    fprintf(stderr, " RAD_LOOP  = loop before output to reject bad counts (0 if not set)\n");
    fprintf(stderr, " N_SECTOR  = number of angular sectors (num 0 to N_SECTOR-1), max=%d\n",MAX_SECTORS);
    fprintf(stderr, " A_SECTOR  = origin (degree) of the first sector, if not default is centered on 0\n");
    fprintf(stderr, " RAD_SECTOR = if set (1) and N_SECTOR>8 print angular distribution rather than radial one\n");
    fprintf(stderr, " P_SECTOR  = if not empty, binning specifications without space\n");
    fprintf(stderr, " RAD_X_ANG = if not empty, error angle (rad) along x, RAD_Y_ANG\n");
    fprintf(stderr, " RAD_D_PIXELS = if not empty, center of cone distance (pixels) for RAD_X_ANG, RAD_Y_ANG\n");
    fprintf(stderr, " RAD_X   = if not empty, X geometrical transformation, RAD_Y\n");
    fprintf(stderr, " RAD_DX  = if not empty, X geometrical density related to RAD_X, RAD_DY\n");
    fprintf(stderr, " RAD_DRAW  = if not empty, add 1 to 10 circles on image\n");
    fprintf(stderr, " RAD_EXEC  = if not empty, program and args to run in which $ stand for the rad file\n");
    fprintf(stderr, " RAD_PRINT  = if not empty, +1 remove comments between data\n");
    fprintf(stderr, "    radial distribution example, N=8,P=0+4,2+6,1+3+5+7 print 3 curves\n");
    fprintf(stderr, "  if grid is corrected on the fly, specify GRID_ORIG=CONVERT to convert the origin\n");
    }
/*-----------------------------------------------------------*/
int ini_radial(char * tag, char * arg)
{   char *stdin_name = NULL;
	 if (prg_iniflt( tag, arg, "RADIUS",   &radius)) return 1; 
/*    if (prg_iniflt( tag, arg, "RAD_MIN",  &rad_min)) return 1; */
    if (prg_iniflt( tag, arg, "RAD_MAX",  &rad_max)) return 1; 
    if (prg_iniflt( tag, arg, "RAD_OFF",  &rad_off)) return 1; 
    if (prg_iniint( tag, arg, "RAD_LOOP", &rad_loop)) return 1;
    if (prg_iniint( tag, arg, "RAD_SECTOR", &rad_sector)) return 1;
    if (prg_iniint( tag, arg, "RAD_PRINT", &rad_print)) return 1;
    if (prg_iniint( tag, arg, "N_SECTOR", &n_sector)) return 1;
    if (prg_iniflt( tag, arg, "A_SECTOR", &a_sector)) return 1;
    if (prg_inistr( tag, arg, "P_SECTOR", &p_sector)) return 1;
    if (prg_inistr( tag, arg, "RAD_X",    &rad_x)) return 1;
    if (prg_inistr( tag, arg, "RAD_Y",    &rad_y)) return 1;
    if (prg_inistr( tag, arg, "RAD_DX",   &rad_dx)) return 1;
    if (prg_inistr( tag, arg, "RAD_DY",   &rad_dy)) return 1;
    if (prg_inidbln( tag, arg, "RAD_DRAW", rad_draw, 4)) return 1;
    if (prg_iniflt( tag, arg, "RAD_X_ANG", &rad_x_ang)) return 1;
    if (prg_iniflt( tag, arg, "RAD_Y_ANG", &rad_y_ang)) return 1;
    if (prg_iniflt( tag, arg, "RAD_X_ORIG", &rad_x_orig)) return 1;
    if (prg_iniflt( tag, arg, "RAD_Y_ORIG", &rad_y_orig)) return 1;
    if (prg_iniflt( tag, arg, "RAD_D_PIXELS", &rad_d_pixels)) return 1;
    if (prg_inistr( tag, arg, "RAD_EXEC", &rad_exec)) return 1;
    return 0;
	 }
/*-----------------------------------------------------------*/
#ifndef M_PI
#define M_PI               3.14159265358979323846
#endif
static void store_check(int s, int n, int i, double w, double val, double dens);
double **s_r, **q_r, **n_r;
double **vma_r, **vmi_r;
int    **ima_r, **imi_r;
void radial(char * name, char *path, IMAGE *img)
{   int i, j, ix, iy, n, s, dim, loop, loop_rejected;
    double xx, x, y, z;
    double center_x, center_y;
    float r, rmax, a, dr, w;
    FLOAT64 val;
    FRAMES *frame = img->frame;
    double dens_x, dens_y, dens;
    FILE *f_out;
    char *c, rad_outname[200];

    if (a_sector >999) a_sector=-180.0/n_sector;
    loop_rejected=0;
    if (img->data.i == NULL &&  img->data.f == NULL) V_ERROR("no data to write");
    if (name && *name)   strcpy (rad_outname, name); 
    else
    {  if (path) 
       {   strcpy (rad_outname, path);    
           c = strrchr(rad_outname,'/');
           if ( !c || c - rad_outname != strlen(rad_outname)-1 ) strcat(rad_outname, "/");
           }
       else rad_outname[0]=0;
       c = strrchr(img->name,'/');
       if ( c )  c++; else c = img->name;
       strcat (rad_outname, c);
       }
    c = strrchr(rad_outname, '/');
    if ( !c ) c = rad_outname;
    c = strrchr(c, '.');
    if ( c ) *c = 0;
    if (d_name) strcat (rad_outname, "d");
    if (f_name) strcat (rad_outname, "f");
    if (g_name) strcat (rad_outname, "g");
    strcat (rad_outname, ".rad");
    
    prg_printf ("# output radial results in %s\n", rad_outname);     
    f_out = fopen(rad_outname, "w");
    center_x = ( orig_x == 0.0) ? image.x_size/2.0 : orig_x;
    center_y = ( orig_y == 0.0) ? image.y_size/2.0 : orig_y;
    rad_x_cos=cos(rad_x_ang);
    rad_y_cos=cos(rad_y_ang);
    if (rad_d_pixels) 
    {   rad_x_sin=sin(rad_x_ang)/rad_d_pixels;
        rad_y_sin=sin(rad_y_ang)/rad_d_pixels;
        }
    if (grid_orig && strstr("CONVERT",grid_orig))
    {   double gsx, gsy;
        gsx = grid_pix_xcor(center_x, &grid_cor);
        gsy = grid_pix_ycor(center_y, &grid_cor);
        x=grid_cor_xpos(gsx,gsy,&grid_cor);
        y=grid_cor_ypos(gsx,gsy,&grid_cor);
        printf ("using grid corrected center %.3f %.3f for %.3f %.3f\n", 
               x, y, center_x, center_y);
        center_x=x;
        center_y=y;
        }
    center_x -= image.x_omin;
    center_y -= image.y_omin;
    center_x /= image.x_obind;
    center_y /= image.y_obind;
    xy_orien_pixel(&image, &center_x, &center_y, 1);
    rmax = 0;
    if ( (a=center_x*center_x + center_y*center_y) > rmax ) rmax = a;
    if ( (a=center_x*center_x + (image.y_size-center_y)*(image.y_size-center_y)) > rmax ) rmax = a;
    if ( (a=(image.x_size-center_x)*(image.x_size-center_x) + center_y*center_y) > rmax ) rmax = a;
    if ( (a=(image.x_size-center_x)*(image.x_size-center_x) + (image.y_size-center_y)*(image.y_size-center_y)) > rmax ) rmax = a;
    rmax = sqrt(rmax+1);
    if ( radius < 1 ) radius = 1;
    dim = 3 + rmax / radius;
    prg_printf ("# center %.2f %.2f -> %.2f %.2f, r_max %.2f,  dim %d, r_bind %.2f r_offset %.2f\n", 
        orig_x, orig_y, center_x, center_y, rmax, dim, radius, rad_off );
    if (n_sector < 1 || n_sector > MAX_SECTORS ) n_sector = 1;
    prg_printf ("# %d sectors (MAX=%d) with origine of first sector starting at %.2f deg, first sector center : %.2f\n", n_sector, MAX_SECTORS, a_sector, 180.0/n_sector+a_sector);
    fprintf (f_out, "# %s (%d-%d)/%d*(%d-%d)/%d  (%s)\n\
# center %.2f %.2f -> %.2f %.2f, r_max %.2f\n\
# radius binding according to : RAD_OFF(%.1f)+n*RADIUS(%.1f) < RAD_OFF+(n+1)*RADIUS\n\
# %d sectors with origine at %.2f deg, first sector center : %.2f deg\n", rad_outname, 
	image.x_omin, image.x_omax, image.x_obind, 
	image.y_omin, image.y_omax, image.y_obind, i_name ? i_name:"",
	orig_x, orig_y, center_x, center_y, rmax, rad_off, radius,
   n_sector, a_sector, 180.0/n_sector+a_sector);
    
    if ( rad_x) 
    {  ini_transfo_coord(rad_x, 0);
       center_x = transfo_coord(0, center_x, center_y);
       }
    if ( rad_dx)  ini_transfo_coord(rad_dx, 2);
    if ( rad_y) 
    {  ini_transfo_coord(rad_y, 1);
       center_y = transfo_coord(1, center_x, center_y);
       }
    if ( rad_dy)  ini_transfo_coord(rad_dy, 3);
    /* arrays to alloc arrays for each sector */
    s_r = (double**) malloc(n_sector*sizeof(double*));  /* sum of weighted counts */
    q_r = (double**) malloc(n_sector*sizeof(double*));  /* sum of weighted squared counts */
    n_r = (double**) malloc(n_sector*sizeof(double*));  /* sum of weighted density */
    vma_r = (double**) malloc(n_sector*sizeof(double*));  /* max value */
    vmi_r = (double**) malloc(n_sector*sizeof(double*));  /* min value */
    ima_r = (int**) malloc(n_sector*sizeof(int*));       /* max value position */
    imi_r = (int**) malloc(n_sector*sizeof(int*));
    dens_x = 1.0;
    dens_y = 1.0;
    for (s = 0; s < n_sector; s++)
    {   s_r[s] = (double*) malloc(dim*sizeof(double));
        q_r[s] = (double*) malloc(dim*sizeof(double));
        n_r[s] = (double*) malloc(dim*sizeof(double));
        vma_r[s] = (double*) malloc(dim*sizeof(double));
        vmi_r[s] = (double*) malloc(dim*sizeof(double));
        ima_r[s] = (int*)    malloc(dim*sizeof(int));
        imi_r[s] = (int*)    malloc(dim*sizeof(int));
        }
    for ( loop=0; loop<=rad_loop; loop++)
    {   int rejected=0;
        for (s = 0; s < n_sector; s++)
        {   memset(s_r[s], 0, dim*sizeof(double));
            memset(q_r[s], 0, dim*sizeof(double));
            memset(n_r[s], 0, dim*sizeof(double));
            memset(vma_r[s], 0, dim*sizeof(double));
            memset(vmi_r[s], 0, dim*sizeof(double));
            memset(ima_r[s], 0, dim*sizeof(int));
            memset(imi_r[s], 0, dim*sizeof(int));
            }
        for (i = 0; i <image.size; i++)
        {    if ( frame[i]==0 ) continue;
             ix = i % image.x_size;
             iy = i / image.x_size;
             if ( rad_dx)  dens_x = transfo_coord(2, ix, iy);
             if ( rad_dy)  dens_y = transfo_coord(3, ix, iy);
             if ( rad_x) x = transfo_coord(0, ix, iy);
             else x = 0.5+ix;
             if ( rad_y) y = transfo_coord(1, ix, iy);
             else y = 0.5+iy;
             r = rad_hypot(x,y,center_x,center_y);
             a = rad_atan(x,y,center_x,center_y);
             n = (r - rad_off) / radius;
             if ( n >= dim || n < 0) continue;
             dr = r - rad_off - n * radius;
             s= n_sector * ( a + 360.0 - a_sector ) / 360.0;
             s %= n_sector;
             while ( s < 0 ) s+= n_sector;
             dens= dens_x * dens_y;
             val = xy_floatvalue(img,i);
             if (dr >  0.5 + radius - 1)
             {  float ds;
                ds = radius - dr;
                store_check(s, n, i, 1.0 - ds, val, dens);
                if (n+1<dim) store_check(s, n+1, i, ds, val, dens);
                }
             else if (dr < 0.5)
             {  float ds;
                ds = 0.5 - dr;
                if (n) 
                {   store_check(s, n, i, 1.0 - ds, val, dens);
                    store_check(s, n-1, i, dr, val, dens);
                    }
                else  store_check(s, n, i, 1.0, val, dens);
                }
             else
             {  store_check(s, n, i, 1.0 , val, dens);
                }
            }
        if  (loop < rad_loop)
        {   double delta, deltami, deltama;
            deltama=0;
            deltami=MAXFLOAT;
            for (s = 0; s < n_sector; s++) 
            for (n = 0; n < dim; n++)  
            if ( n_r[s][n] > 3 )
            {  x = n_r[s][n];
               y = s_r[s][n] / x;
               z = sqrt((q_r[s][n] - x * y *y) / (x -1.0));
               if (vma_r[s][n] + vmi_r[s][n] > y )
               {   delta = (vma_r[s][n]-y)/z;
                   i= ima_r[s][n];
                   }
               else
               {   delta = (y - vmi_r[s][n])/z;
                   i= imi_r[s][n];
                   }     
               if ( delta > rad_loop_tol && frame[i])
               {   frame[i] = 0;
                   rejected++;
                   if (delta > deltama) deltama=delta;
                   if (delta < deltami) deltami=delta;
                   }
               } 
            printf  ("rad_loop %d rejects %d pixels", loop, rejected);
            if (rejected ) printf  (" e/s : %.1lf - %.1lf\n", deltami,deltama);
            else printf  ("\n");
            loop_rejected +=rejected;
            if ( rejected == 0 ) break;
            }  
        } /* rad_loops */ 
    if (rad_loop > 1 ) 
    {   prg_printf ("# %d pixels rejected in %d loops (%.1lf sigma) \n",
        loop_rejected, rad_loop, rad_loop_tol);
        fprintf (f_out, "# %d pixels rejected in %d loops (%.1lf sigma) \n",
        loop_rejected, rad_loop, rad_loop_tol);
        }
    if (p_sector==NULL) 
	 {  if (n_sector == 1) 
       {  fprintf (f_out, "#   r      s/n       e(s/n)   n  ...%c\n", cr_mode==0?' ':'\r');
          s = 0;
          for (n = 0; n < dim; n++)
          {  r=n*radius+rad_off;
             if (r < rad_off || r > rad_max ) continue;
             ini_rad_line(r);
             x = n_r[s][n];
             if (x < 0.1) x = 1;
             y = s_r[s][n] / x;
/*             if (  y < rad_min ) y = rad_min;*/
				 z = (q_r[s][n] - x * y *y) / (x - 0.999999 );
             if ( z > 0 && x > 2.0) z = sqrt(z / x) ; else z =-1.0;
             add_rad_line(y,z,n_r[s][n]);
             writen_lines+=end_rad_line(f_out);
				 }
           }
       else if (n_sector < 8) 
       {  float asf=360.0/n_sector;
          fprintf (f_out, "# sector centers : ");
          for (s = 0; s < n_sector; s++) fprintf (f_out, "  %d->%.2f", s, (s+0.5)*asf+a_sector);
          fprintf (f_out, "%c\n", cr_mode==0?' ':'\r');
          fprintf (f_out, "#   r   s[0]/n[0]  s[1]/n[1]   ...     e(s[0]/n[0])  e()  ...  n[0] n[1] ...%c\n", cr_mode==0?' ':'\r');
          for (n = 0; n < dim; n++)
          {  r=n*radius+rad_off;
             if (r < rad_off || r > rad_max ) continue;
             ini_rad_line(r);
             for (s = 0; s < n_sector; s++)
             {  x = n_r[s][n];
                if (x < 0.1) x = 1;
                y = s_r[s][n] / x;
/*                if (  y < rad_min ) y = rad_min;*/
				    z = (q_r[s][n] - x * y *y) / (x - 0.999999 );
                if ( z > 0 && x > 2.0) z = sqrt(z / x) ; else z =-1.0;
                q_r[s][n]=z;
                add_rad_line_y(y);
				    }
             add_rad_line_space();
             for (s = 0; s < n_sector; s++) add_rad_line_z(q_r[s][n]);
             add_rad_line_space();
             for (s = 0; s < n_sector; s++) add_rad_line_n(n_r[s][n]);
             writen_lines+=end_rad_line(f_out);
             }
           }
       else if (! rad_sector) 
       {  float asf=360.0/n_sector;
          fprintf (f_out, "# sector centers : ");
          for (s = 0; s < n_sector; s++) fprintf (f_out, "  %d->%.2f", s, (s+0.5)*asf+a_sector);
          fprintf (f_out, "%c\n", cr_mode==0?' ':'\r');
          fprintf (f_out, "#   r   s[0]/n[0]  s[1]/n[1]   ...%c\n", cr_mode==0?' ':'\r');
          for (n = 0; n < dim; n++)
          {  r=n*radius+rad_off;
             if (r < rad_min || r > rad_max ) continue;
             ini_rad_line(r);
             for (s = 0; s < n_sector; s++)
             {  x = n_r[s][n];
                if (x < 0.1) x = 1;
                y = s_r[s][n] / x;
/*                if (  y < rad_min ) y = rad_min; */
				    z = (q_r[s][n] - x * y *y) / (x - 0.999999 );
                if ( z > 0 && x > 2.0) z = sqrt(z / x) ; else z =-1.0;
                q_r[s][n]=z;
                add_rad_line_y(y);
				    }
             writen_lines+=end_rad_line(f_out);
             }
          if (rad_print & 0x1 == 0)  fprintf (f_out, "#   r   e(s[0]/n[0])  e()  ... %c\n", cr_mode==0?' ':'\r');
          for (n = 0; n < dim; n++)
          {  r=n*radius+rad_off;
             if (r < rad_off || r > rad_max ) continue;
             ini_rad_line(r);
             for (s = 0; s < n_sector; s++) add_rad_line_z(q_r[s][n]);
             writen_lines+=end_rad_line(f_out);
             }
          fprintf (f_out, "#   r    n[0] n[1] ...%c\n", cr_mode==0?' ':'\r');
          for (n = 0; n < dim; n++)
          {  r=n*radius+rad_off;
             if (r < rad_off || r > rad_max ) continue;
             ini_rad_line(r);
             for (s = 0; s < n_sector; s++) add_rad_line_n(n_r[s][n]);
             writen_lines+=end_rad_line(f_out);
             }
           }
       else  /* print out radial distribution */
       {  float asf=360.0/n_sector;
          fprintf (f_out, "# radius centers : ");
          for (n = 0; n < dim; n++)
          {  r=n*radius+rad_off;
             if (r < rad_off || r > rad_max ) continue;
             fprintf (f_out, "  %.2f", r);
             }
          fprintf (f_out, "%c\n", cr_mode==0?' ':'\r');
          fprintf (f_out, "#   a   r[0]/n[0]  r[1]/n[1]   ...%c\n", cr_mode==0?' ':'\r');
          for (s = 0; s < n_sector; s++)
          {  ini_rad_line((s+0.5)*asf+a_sector);
             for (n = 0; n < dim; n++)
             {  r=n*radius+rad_off;
                if (r < rad_off || r > rad_max ) continue;
                x = n_r[s][n];
                if (x < 0.1) x = 1;
                y = s_r[s][n] / x;
/*                if (  y < rad_min ) y = rad_min;
*/				    z = (q_r[s][n] - x * y *y) / (x - 0.999999 );
                if ( z > 0 && x > 2.0) z = sqrt(z / x) ; else z =-1.0;
                q_r[s][n]=z;
                add_rad_line_y(y);
				    }
             writen_lines+=end_rad_line(f_out);
             }
          fprintf (f_out, "#   a   e(r[0]/n[0])  e()  ... %c\n", cr_mode==0?' ':'\r');
          for (s = 0; s < n_sector; s++)
          {  ini_rad_line((s+0.5)*asf+a_sector);
             for (n = 0; n < dim; n++)
             {  r=n*radius+rad_off;
                if (r < rad_off || r > rad_max ) continue;
                add_rad_line_z(q_r[s][n]);
				    }
             writen_lines+=end_rad_line(f_out);
             }
          fprintf (f_out, "#   a    n[0] n[1] ...%c\n", cr_mode==0?' ':'\r');
          for (s = 0; s < n_sector; s++)
          {  ini_rad_line((s+0.5)*asf+a_sector);
             for (n = 0; n < dim; n++)
             {  r=n*radius+rad_off;
                if (r < rad_off || r > rad_max ) continue;
                add_rad_line_n(n_r[s][n]);
				    }
             writen_lines+=end_rad_line(f_out);
             }
           }
        prg_printf ("# %d * %d data writen in %s, %d valid lines\n", dim, n_sector, rad_outname, writen_lines);
		  } 
     else  /* binning sectors */
	  {  char *d;
	     int e, b_sector, u, us, *used_sector;
		  used_sector = (int *) malloc(n_sector*sizeof(int));
		  fprintf (f_out, "# print sectors binned according : '%s'%c\n", p_sector, cr_mode==0?' ':'\r');
		  fflush(f_out);
        if (used_sector==NULL)
		  {   fprintf(stderr, "unable to allocate memory for sectors definition!!\n");
		      exit(3);
				}
		  for (i=0;i<n_sector;i++) used_sector[i]=0;		
		  b_sector = us = 0;
		  e = 0;
		  d = p_sector;
		  while (*d)
		  {  while ( sscanf(d,"%d", &u) == 1)
			  {  if ( u >= n_sector )	
			     {   printf (" invalid sector %d ( >= %d ), skipped!\n", u, n_sector );
				      fprintf (f_out," invalid sector %d ( >= %d ), skipped!\n", u, n_sector );
                  exit(3);
                  }
			     if ( used_sector[u] )	
			     {   printf (" sector %d used more than one times!\n", u);
				      fprintf (f_out," sector %d used more than onc times!\n", u);
				      exit(3);
                  }
			     e++;
				  used_sector[u] = b_sector+1;
				  us++;
				  if (*d=='+') d++;
				  while (isdigit(*d)) d++;
				  if (*d==','||*d==0) break;
				  }
		      e=0;
				if (*d==',') d++;
				b_sector++;
				}
        fprintf(f_out, "# %d used sectors (of %d) are binned in %d group : ", us, n_sector, b_sector);
		  for (i=0;i<b_sector;i++) 		
		  {  fprintf(f_out, " %d (",i );
		  	  for (j=0;j<n_sector;j++)  if (used_sector[j] == i+1) 	fprintf(f_out, " %d", j);
		  	  fprintf(f_out, ") %s", (i+1==b_sector)?"\n":" , " );
			  }
	     fprintf (f_out, "#   r       s/n       e(s/n)    n  ...%c\n", cr_mode==0?' ':'\r');
		  fflush(f_out);
        for (n = 0; n < dim; n++)
        {   r=n*radius+rad_off;
            if (r < rad_off || r > rad_max ) continue;
            ini_rad_line(r);
		      for (j = 0; j < b_sector; j++)
            {   xx = y = z = 0;
				    for (s = 0; s < n_sector; s++)
                {  if (used_sector[s] != j+1 ) continue;
					    xx += n_r[s][n];
						 y += s_r[s][n];
						 z += q_r[s][n];
						 }
                x = (xx < 0.1) ? 1 : xx;
                y /= x;
/*                if (  y < rad_min ) y = rad_min;  */
                z = (z - x * y *y) / (x - 0.99999 );
                if ( z > 0 && x > 2.0) z = sqrt(z / x) ; else z =-1.0;
                add_rad_line(y, z, xx);
                }
            writen_lines+=end_rad_line(f_out);
				
            }
		  free(used_sector);	
        prg_printf ("# %d * %d data writen in %s, %d valid lines\n", dim, b_sector, rad_outname, writen_lines);
	     }	  
    fclose (f_out);
    if (rad_exec) prg_fork("RAD_EXEC",rad_exec,rad_outname);
    if ( rad_x ||  rad_y) end_transfo_coord();
    for (s = 0; s < n_sector; s++)
    {   free( s_r[s]); 
        free( q_r[s]);
        free( n_r[s]);
        free( vma_r[s]);
        free( vmi_r[s]);
        free( ima_r[s]);
        free( imi_r[s]);
        }
    free( s_r );
    free( q_r );
    free( n_r );
    free( vma_r);
    free( vmi_r);
    free( ima_r);
    free( imi_r);
    draw_radial(img, center_x, center_y);
    }
/*-----------------------------------------------------------*/
static void store_check(int s, int n, int i, double w, double val, double dens)
{   s_r[s][n] += w * val;
    q_r[s][n] += w * val * val;
    n_r[s][n] += w * dens;
    if (val > vma_r[s][n])
    {   vma_r[s][n] = val;
        ima_r[s][n] = i;
        } 
    else
    if (val < vmi_r[s][n])
    {   vmi_r[s][n] = val;
        imi_r[s][n] = i;
        } 
    }    
/*-----------------------------------------------------------*/
void ini_rad_line(float r)
{   sprintf (rad_line, " %5.1f", r);
    valid_rad_line=0;
	 }
/*-----------------------------------------------------------*/
void add_rad_line_y(double y)
{   char *c;
    c=rad_line + strlen(rad_line);
    sprintf (c, " %10.2lf", y);
    if ( y > 0 ) valid_rad_line++;
	 }
/*-----------------------------------------------------------*/
void add_rad_line_z(double z)
{   char *c;
    c=rad_line + strlen(rad_line);
    sprintf (c, " %8.2lf", z);
    if ( z > 0 ) valid_rad_line++;
	 }
/*-----------------------------------------------------------*/
void add_rad_line_n(double n_r)
{   char *c;
    c=rad_line + strlen(rad_line);
    sprintf (c, " %6.1lf", n_r);
	 }
/*-----------------------------------------------------------*/
void add_rad_line_space()
{   char *c;
    c=rad_line + strlen(rad_line);
    sprintf (c, "   ");
	 }
/*-----------------------------------------------------------*/
void add_rad_line(double y, double z, double n_r)
{   char *c;
    c=rad_line + strlen(rad_line);
    sprintf (c, "  %10.2lf %8.2lf %6.1lf  ", y, z, n_r);
    if ( y > 0 || z > 0 ) valid_rad_line++;
	 }
/*-----------------------------------------------------------*/
int end_rad_line(FILE * f_out)
{   if (valid_rad_line)
    {  fprintf (f_out, "%s%c\n", rad_line, cr_mode==0?' ':'\r');
	    return 1;
		 }
	 return 0;	 
	 }
/*-----------------------------------------------------------*/
void draw_radial(IMAGE *img, double center_x, double center_y)
{  int i, j, nb=0;
	FLOAT64 *f;
   for (i=0;i<10;i++) if ( rad_draw[i] > 0 ) nb++;
   if (nb==0) return;
	printf("# adding %d circles at ", nb);
   for (j=0;j<nb;j++)  printf(" %.1lf ", rad_draw[j]);
	printf(" on image\n");
   f=xy_needsfloat(img);
   radial_drawn = nb;
   for (i = 0; i <image.size; i++)
   {  int ix,iy;
      double r,x,y;
      ix = i % image.x_size;
      iy = i / image.x_size;
      if ( rad_x) x = transfo_coord(0, ix, iy);
      else x = ix;
      if ( rad_y) y = transfo_coord(1, ix, iy);
      else y = iy;
      r = rad_hypot( x, y,center_x, center_y);
      for (j=0;j<nb;j++)  if (fabs(r-rad_draw[j])<1)   f[i]=-1000;
       }
   }
/*-----------------------------------------------------------*/
double rad_hypot(double x, double y, double cx, double cy)
{  double xx, yy, cxx, cyy;
   if (rad_x_orig)
   {   x-=rad_x_orig;
       cx-=rad_x_orig;
       }
   else    
   {   x-=cx;
       cx=0;
       }
   if (rad_y_orig)
   {   y-=rad_y_orig;
       cy-=rad_y_orig;
       }
   else    
   {   y-=cy;
       cy=0;
       }
   if (rad_d_pixels)
   {   xx = x*rad_x_cos /(1 + x * rad_x_sin);
       yy = y*rad_y_cos /(1 + y * rad_y_sin);
       cxx = cx*rad_x_cos /(1 + cx * rad_x_sin);
       cyy = cy*rad_y_cos /(1 + cy * rad_y_sin);
       }
   else
   {   xx = x*rad_x_cos;
       yy = y*rad_y_cos;
       cxx = cx*rad_x_cos;
       cyy = cy*rad_y_cos;
       }
   xx -= cxx;
   yy -= cyy;
   return sqrt(xx*xx+yy*yy); /* hypot(xx,yy) ??? */  
   }
/*-----------------------------------------------------------*/
double rad_atan(double x, double y, double cx, double cy)
{  double xx, yy, cxx, cyy;
   if (rad_x_orig)
   {   x-=rad_x_orig;
       cx-=rad_x_orig;
       }
   else    
   {   x-=cx;
       cx=0;
       }
   if (rad_y_orig)
   {   y-=rad_y_orig;
       cy-=rad_y_orig;
       }
   else    
   {   y-=cy;
       cy=0;
       }
   if (rad_d_pixels)
   {   xx = x*rad_x_cos /(1 + x * rad_x_sin);
       yy = y*rad_y_cos /(1 + y * rad_y_sin);
       cxx = cx*rad_x_cos /(1 + cx * rad_x_sin);
       cyy = cy*rad_y_cos /(1 + cy * rad_y_sin);
       }
   else
   {   xx = x*rad_x_cos;
       yy = y*rad_y_cos;
       cxx = cx*rad_x_cos;
       cyy = cy*rad_y_cos;
       }
   xx -= cxx;
   yy -= cyy;
   return 180*atan2(yy, xx)/ M_PI; 
   }
/*-----------------------------------------------------------*/
  
