static char *cvs_id =" $Id: prg_lib.c,v 1.7 2005/01/06 14:37:05 berar Exp $ ";
/*  prg_lib.c  */
#include "prg_def.h"
#include <errno.h>
/*-----------------------------------------------------------*/
#ifdef __WIN32__
#define PATH_CHAR '\\'
#define PATH_STR  "\\"
#else
#define PATH_CHAR '/'
#define PATH_STR  "/"
#endif
/*-----------------------------------------------------------*/
void prg_basename(char *buffer, char *src_name)
{   char *c;
    c = strrchr(src_name, PATH_CHAR);
    if ( !c ) c = src_name; else c++;
    strcpy(buffer, c);
    c=strchr(buffer, '.');
    if ( c ) *c=0;
    }
/*-----------------------------------------------------------*/
void prg_pathname(char *buffer, char *src_name)
{   char *c;
    strcpy( buffer, src_name);
    c = strrchr(buffer, PATH_CHAR);
    if ( !c ) c = buffer; else c++;
    *c=0;
    }
/*-----------------------------------------------------------*/
void prg_extname(char *buffer, char *src_name)
{   char *c;
    strcpy( buffer, src_name);
    c = strchr(src_name, '.');
    if ( c ) strcpy( buffer, c);
    else *buffer = 0;
    }
/*-----------------------------------------------------------*/
void prg_outname(char *buffer, char *name, char *def_name, char *def_ext, char *def_path)
{   char *c, b[200];
    prg_pathname(b, name);
    if (*b == 0 && def_path) strcpy(b, def_path);
    if ( *b )
    {  c = strrchr(b, PATH_CHAR);
       if ( !c || c - b != strlen(b)-1 ) strcat(b, PATH_STR);
       }
    strcpy (buffer, b);
    prg_basename(b, name);
    if (*b == 0 && def_name) prg_basename(b, def_name);
    strcat (buffer, b);
    if (def_ext) strcat(buffer, def_ext);
    }
/*-----------------------------------------------------------*/
char * prg_get_line(char * buffer, int buflen, FILE * inf)
{  char *c, *d, *e; 
	buffer[0]=0;
	fgets(buffer, buflen-1, inf);
   if ((d=strrchr(buffer, '\n'))) *d=0;
   if ((d=strrchr(buffer, '\r'))) *d=0;
	c = buffer;
	while ( *c == ' ' ) c++;
	if (*c==0 || *c == '#') return NULL;
   if ((e=strchr(c, '#'))) *e=0;
	e = c + strlen(c) - 1;
	while ( *e == ' '  && e != c ) e--;
	++e; *e=0;
	return c;
	}      
/*-----------------------------------------------------------*/
char * prg_get_name(char *tag, char * buffer)
{  char *c, *d, *e; 
	c = buffer + strlen(tag);
	while ( *c == ' ' || *c == '=') c++;
	e = c;
	while ( *e && *e != ' ') e++;
	*e=0;
	d = str_alloc(c);
	return d;
	}      
/*-----------------------------------------------------------*/
char * prg_get_names(char *tag, char * buffer)
{  char *c, *d; 
	c = buffer + strlen(tag);
	while ( *c == ' ' || *c == '=') c++;
	d = str_alloc(c);
	return d;
	}      
/*-----------------------------------------------------------*/
void prg_home_name(char ** file_name)
{  char *c,*d,buffer[500];
   if (**file_name != '~') return;
   c=*file_name;
   if (c[1] != '/') 
        v_error("prg_home_name", "unable to expand file name '%s' for other users", c);
   d = str_alloc(strcat (getenv("HOME"), c+1));
   free (*file_name);
   *file_name=d;
   }      
/*-----------------------------------------------------------*/
void prg_fork(char * label, char *command, char *arg)
{  char *buf,*p;
   int i;
   if (command == NULL || strlen(command)==0) return;
   buf = malloc(strlen(command) + strlen(arg)+20);
   strcpy(buf,command);
   p = strstr(command,"$");
   if (p )
   {  buf[p-command] = 0;
      strcat(buf,arg);
      p+=1;
      strcat(buf,p);
      }
   printf ("prg_fork %s  '%s'\n",label, buf);
   system(buf);
   }
/*-----------------------------------------------------------*/
static void (*param_proc) (FILE *)=NULL;
void prg_inifile( void parameter(FILE *f_ini) )
{   char buffer[200];
    FILE * f_ini;
    param_proc=parameter;
    prg_basename(buffer, prg_name);
    strcat(buffer, ".ini");
    f_ini = fopen( buffer, "r");
    if ( f_ini != NULL )
    {   printf(" using file '%s'\n", buffer);
        (*param_proc) ( f_ini);
        fclose (f_ini);
        }
    else printf( " no file '%s' using defaults\n", buffer);
   }
/*-----------------------------------------------------------*/
void prg_iniuse(char *name)
{  fprintf(stderr, "valid options in %s.ini files are : \n", name);
   fprintf(stderr, " LOG = 0 (none), 1 (new0 or 2 (append)\n");
   fprintf(stderr, " FILE = redirection in the ini file\n");
     
   }
/*-----------------------------------------------------------*/
int prg_initag(char *b, char **tag, char **arg)
{   char *d, *e;
    char *file_name = NULL;
    while (*b == ' ' || *b == '\n' || *b == '\r') b++;
    *tag = *arg = NULL;
	 if (*b=='#' || *b==0) return 0;
    *tag=b;
    if ( (d=strchr(b, '#'))) *d =0;
	 if ( (e=strchr(b, '='))) *e =0;
	 d=b+strlen(b)-1;
    while (*d==' ') d--;
	 *(d+1)=0;
	 if (**tag==0) return 0;
	 if (e)
    { d=e+1;
      while (*d==' ') d++;
	   *arg=d;
	   d+=strlen(d)-1;
      while (*d==' ' || *d== '\n' || *d== '\r') d--;
	   *(d+1)=0;
      }
    else *arg=NULL;  
    if ( prg_inistr(*tag, *arg, "FILE", &file_name) ) 
    {   FILE *f_ini;
        prg_home_name(&file_name);
        f_ini = fopen(file_name,"r");   
        if ( f_ini != NULL )
        {   printf("now using file '%s'\n", file_name);
            (*param_proc) ( f_ini);
            fclose (f_ini);
            printf("end of file '%s', back to previous file\n", file_name);
            free(file_name);
            return 0;
            }
        else v_error("prg_initag","unable to open file %s", file_name);
        }
    return !prg_iniint(*tag, *arg, "LOG", &log_mode);	  
  }   
/*-----------------------------------------------------------*/
int prg_inistr(char *tag, char *arg, char *key, char **s)
{   char *d, *e;
    if ( strcmp(tag, key) != 0 ) return 0;
    *s = malloc(1+strlen(arg));
    strcpy(*s, arg);
    printf(" %10s= '%s'\n", key, *s);
    return 1;
  }   
/*-----------------------------------------------------------*/
int prg_iniint(char *tag, char *arg, char *key, int *d)
{   if ( strcmp(tag, key) != 0 ) return 0;
    sscanf(arg," %d", d);
    printf(" %10s= %d\n", key, *d);
    return 1;
    }   
/*-----------------------------------------------------------*/
int prg_iniflt(char *tag, char *arg, char *key, float *f)
{   if ( strcmp(tag, key) != 0 ) return 0;
    sscanf(arg," %f", f);
    printf(" %10s= %g\n", key, *f);
    return 1;
    }   
/*-----------------------------------------------------------*/
int prg_inidbl(char *tag, char *arg, char *key, double *f)
{   if ( strcmp(tag, key) != 0 ) return 0;
    sscanf(arg," %lf", f);
    printf(" %10s= %lg\n", key, *f);
    return 1;
    }   
/*-----------------------------------------------------------*/
int prg_inidbln(char *tag, char * arg, char *key, double *d, int n)
{   int i, r;
    if ( strcmp(tag, key) != 0 ) return 0;
    if (n<=0) n=1;
    printf(" %10s=", key);
    for (i=0;i<n;i++,d++) 
    {   if (i && i%4==0) printf("\n %10s=", "...");
        sscanf(arg," %lf%n", d, &r);
        printf(" %14lg ", *d);
        arg+=r;
        }
    printf("\n");
    return 1;
    }   
/*-----------------------------------------------------------*/
int prg_inidblt(char *tag, char * arg, char *key, double *d, int n)
{   int i, p, c, r;
    if ( strcmp(tag, key) != 0 ) return 0;
    sscanf(arg," %d%n", &p, &r);
    arg+=r;
    sscanf(arg," %d%n", &c, &r);
    arg+=r;
    printf(" %10s= %2d %2d", key, p, c);
    d+=p;
    for (i=0;i<c;i++,d++) 
    {   sscanf(arg," %lf%n", d, &r);
        printf(" %14lg ", *d);
        arg+=r;
        }
    printf("\n");
    return 1;
    }   
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
char * str_alloc(char * model)
{  char *p;
   p = (char *) malloc(1+strlen(model));
   if (p == NULL) v_error(__FILE__, " : allocating string : '%s' %d\n", model, strlen(model));
   strcpy(p, model);
   return p;
  }
/*-----------------------------------------------------------*/
void *prg_alloc(char *file, char *name, unsigned long size, int zeroset)
{  void *p;
   p = (void *)malloc(size);
   if (p == NULL) v_error(__FILE__, " %s : allocating memory : %s %d\n", file, name, size);
   if (zeroset) memset(p, 0, size);
   return p;
   }	      
/*-----------------------------------------------------------*/
void *prg_realloc(char *file, char *name, void *ptr, unsigned long size)
{  void *p;
   p = (void *)realloc(ptr, size);
   if (p == NULL) v_error(__FILE__, " %s : reallocating memory : %s %d\n", file, name, size);
   return p;
   }	      
/*-----------------------------------------------------------*/
/* error function : abort with message                       */
/* --------------------------------------------------------- */
#ifdef STDARG
void v_error (char *lib_name, char *format, ... )
{   va_list argptr;

    fprintf (stderr," %s error", lib_name);
    if (errno) fprintf (stderr," (errno=%d)", errno);
    fprintf (stderr," : ");
    va_start (argptr, format);
    vfprintf (stderr, format, argptr);
    va_end (argptr);
    fprintf (stderr,", abort!\n\n");
#ifdef __WIN32__
puts ("\nwaiting keyboard"); getchar();
#endif
    exit(3);
    }
#else
/*  les memes avec varargs............... */
void v_error (va_alist)
va_dcl
{   va_list args;
    char *format;
    fprintf (stderr," %s error (errno=%d) : ", lib_name, errno);
    va_start (args);
    format = va_arg(args, char *);
    vfprintf (stderr,format, args);
    va_end (args);
    exit(3);
    }
#endif
/* ------------------------------------------------------- */
#include <stdarg.h>
int log_mode;
static FILE *log_file;
int prg_printf( char *format, ...)
{  char msg[250];
   int i;
   va_list argptr;
   if (log_mode && log_file == NULL)
   {  strcpy (msg, prg_name);
      strcat (msg, ".log");
      switch (log_mode)
      {  case 1 : log_file = fopen( msg, "w");  break;
         case 2 : log_file = fopen( msg, "a");  break;
         }
      log_mode = 0;
      }
   va_start (argptr, format);
   vsprintf (msg, format, argptr);
   va_end (argptr);
   if (log_file) { fprintf(log_file, "%s", msg);
                   fflush(log_file); }
   i = printf("%s", msg);
   return i;
   }
int prg_fprintf( FILE *f, char *format, ...)
{  char msg[250];
   int i;
   va_list argptr;
   if (log_mode && log_file == NULL)
   {  strcpy (msg, prg_name);
      strcat (msg, ".log");
      switch (log_mode)
      {  case 1 : log_file = fopen( msg, "w");  break;
         case 2 : log_file = fopen( msg, "a");  break;
         }
      log_mode = 0;
      }
   va_start (argptr, format);
   vsprintf (msg,format, argptr);
   va_end (argptr);
   if (log_file) fprintf(log_file, "%s", msg);
   i = fprintf(f, "%s", msg);
   return i;
   }
/*-----------------------------------------------------------*/
int prg_fflush( FILE *f)
{  fflush(f);
   if (log_file) fflush(log_file);
	}
/*-----------------------------------------------------------*/

