static char *cvs_id =" $Id: xy_grid.c,v 1.16 2005/12/20 09:29:16 berar Exp $ ";
/*-----------------------------------------------------------*/
/* grid correction xy_grid.c                                   */
/*-----------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
#define DBG 1
#include "xy_def.h"
/*typedef struct
/*{  int alloc, size, deg, valid; 
/*   double *xcor, *ycor;
/*   double xnorm, ynorm;
/*   void  *internal;
/*   } GRID_COR;
/*   */
typedef struct
{   struct
   {   int ok;
       double gsx, gsy, *value; 
       } tabulated;    /* internal use, reducing time */
   struct              /* binary file image */
   {   int valid, size;
       int xsize, xmin, xbind;
       int ysize, ymin, ybind;
       float *xcor, *ycor; 
       float *dxx, *dyy, *surf; 
       } xy_pos;
   } GRID_INTERNAL;
/* being here is initialized by defect */
GRID_COR grid_cor = {0,0,0,0,NULL,NULL,0,0,NULL};
static char * grid_mode = NULL;
char * grid_orig = NULL;
static int grid_xmin=0;
static int grid_ymin=0;
static int grid_xbind=1;
static int grid_ybind=1;
static double grid_xy_ratio=-1;
static int  grid_deg_xy (int i, int *x, int *y, int retcode);
static void grid_square_onccd(GRID_COR *grid);
static void grid_tabulate_pixel(double x, double y, GRID_COR *grid);
static double grid_cor_dx(double x, double y, GRID_COR *grid, double *cor);
static double grid_cor_dy(double x, double y, GRID_COR *grid, double *cor);
static double grid_cor_surf_diag(double px, double py, GRID_COR *grid, double dxx_yy);
static void   grid_xycalc(GRID_COR *grid, int xsize, int ysize);
/*-----------------------------------------------------------*/
void grid_usage (void)
{   fprintf(stderr,  "\n grid usage parameters :\n");
    fprintf(stderr,  " GRID_AUTO = NONE (default), AUTO apply grid correction\n");
    fprintf(stderr,  " GRID_MODE = NONE (default) FLAT, STRICT, ... see bm2grid.pdf\n");
    fprintf(stderr,  " GRID_DCOR, GRID_XCOR, GRID_XTAB, GRID_NORM...input parameters, see bm2grid\n");
    fprintf(stderr,  " GRID_XYLOAD, GRID_XYSAVE allow to use/keep file of distortions\n");
    fprintf(stderr,  " GRID_ORIG = CONVERT used for radial binding\n");
    fprintf(stderr,  " GRID_CONVERT = x y print transformed coordinates\n");
    fprintf(stderr,  " GRID_XMIN = needed to use only a part of the whole grid, GRID_YMIN \n");
    fprintf(stderr,  " GRID_XBIND = allow to use the whole grid with bindings, GRID_YBIND\n");
    fprintf(stderr,  " GRID_XY_RATIO = ratio to square x and y if not done by grid, no squaring if 0 or -1\n");
    fprintf(stderr,  " the XY_ORIEN parameter works after read, bind and mask\n");
    }                
/*-----------------------------------------------------------*/
int  grid_ini ( GRID_COR *grid, char * tag, char * arg)
{  int n;
   if ( prg_iniint(tag, arg, "GRID_DCOR", &n)) 
   {  grid_struct_ini ( grid, n); 
      return 1;
      } 
   if ( grid->xcor && prg_inidbln(tag, arg, "GRID_XCOR", grid->xcor, grid->size)) 
   {  grid->valid |= 1;
      return 1;
      }
   if ( grid->xcor && prg_inidblt(tag, arg, "GRID_XTAB", grid->xcor, grid->size)) 
   {  grid->valid |= 1;
      return 1;
      }
   if ( grid->ycor && prg_inidbln(tag, arg, "GRID_YCOR", grid->ycor, grid->size)) 
   {  grid->valid |= 2;
      return 1;
      }
   if ( grid->ycor && prg_inidblt(tag, arg, "GRID_YTAB", grid->ycor, grid->size)) 
   {  grid->valid |= 2;
      return 1;
      }
   if ( prg_inistr(tag, arg, "GRID_MODE", & grid_mode)) return 1;
   if ( prg_inistr(tag, arg, "GRID_ORIG", & grid_orig)) return 1;
   if ( prg_iniint(tag, arg,  "GRID_XMIN", & grid_xmin)) return 1;
   if ( prg_iniint(tag, arg,  "GRID_YMIN", & grid_ymin)) return 1;
   if ( prg_iniint(tag, arg,  "GRID_XBIND", & grid_xbind)) return 1;
   if ( prg_iniint(tag, arg,  "GRID_YBIND", & grid_ybind)) return 1;
   if ( prg_inidbl(tag, arg,  "GRID_XY_RATIO", & grid_xy_ratio)) return 1;
   return 0;
   }
/*-----------------------------------------------------------*/
static GRID_INTERNAL * grid_internal_ini (GRID_COR *grid)
{  GRID_INTERNAL *internal=grid->internal;
   if (internal) 
   {   if (internal->tabulated.value) free(internal->tabulated.value);
       free(internal);
       }
   internal= (GRID_INTERNAL *) prg_alloc (__FILE__, "GRID_INTERNAL",sizeof(GRID_INTERNAL),1);
   internal->tabulated.value = (double *) prg_alloc (__FILE__, "tabulated",grid->size*sizeof(double),1);
   internal->tabulated.ok=0;
   internal->xy_pos.valid=0;
   internal->xy_pos.xsize=0;
   internal->xy_pos.xmin=0;
   internal->xy_pos.xbind=0;
   internal->xy_pos.ysize=0;
   internal->xy_pos.ymin=0;
   internal->xy_pos.ybind=0;
   internal->xy_pos.xcor=NULL;
   internal->xy_pos.ycor=NULL;
   internal->xy_pos.dxx=NULL;
   internal->xy_pos.dyy=NULL;
   internal->xy_pos.surf=NULL;
   return internal;
   }
/*-----------------------------------------------------------*/
void  grid_struct_ini ( GRID_COR *grid, int size)
{   int d = 1;
    grid->alloc=grid->size=size;
    while (((d*(d+1))/2) < size ) d++;
    grid->deg=d-1;
    grid->valid=0;
    grid->xnorm=0;
    grid->ynorm=0;
    if (grid->xcor) free (grid->xcor);
    if (grid->ycor) free (grid->ycor);
    grid->xcor = (double *) prg_alloc (__FILE__, "xcor",grid->size*sizeof(double),1);
    grid->ycor = (double *) prg_alloc (__FILE__, "ycor",grid->size*sizeof(double),1);
    grid->internal=grid_internal_ini(grid);
    } 
/*-----------------------------------------------------------*/
void  grid_struct_def ( GRID_COR *grid, int size, int xo, int yo)
{   grid_struct_ini ( grid, size);
    grid->xcor[1]=1;
    grid->ycor[2]=1;
    grid->xcor[0]=xo;
    grid->ycor[0]=yo;
    grid->valid=grid->size=3;
    } 
/*-----------------------------------------------------------*/
void grid_cor_img_old ( GRID_COR *grid, IMAGE *img, int scale )
{  float  *surface;
   double *value;
   long sx,sy,sj;
   long tx,ty,tj;
   double x,xx,y,yy,v,s,surf;
   FLOAT64 *i_value = xy_needsfloat(img);
   FRAMES *frame = img->frame;
   FRAMES *grid_frame;
   long tab[50],itab=0;

   printf ("\n#%s:grid_cor_img  '%s' size=%d(%dx%d)\n", __FILE__, img->name, 
            img->size,img->x_size,img->y_size);
   if (grid->size==0 || grid->valid && 3 != 3)
      v_error(__FILE__, "grid functions are not valid (look at .ini file)");
   if (grid->valid == 3) grid_square_onccd(grid);
   surface = (float *) prg_alloc(__FILE__, "surface", img->size * sizeof(float), 1);
   value = (FLOAT64 *) prg_alloc(__FILE__, "corrected values", img->size * sizeof(double), 1);
   if ( ! i_value ) v_error(__FILE__, "no data in %s", img->name);
   grid_frame = (FRAMES *) prg_alloc(__FILE__, "frame", img->size * sizeof(FRAMES), 1);
   if (!grid_frame )
     if ( grid_mode && !strstr(grid_mode,"STRICT") ) 
           printf(" unable to alloc frame for grid correction and GRID_MODE not STRICT\n");
     else grid_mode="STRICT";
   for (sy=0; sy<img->y_size; sy++)
   {  double gsy=grid_pix_ycor(sy,grid); 
      for (sx=0,sj=sy*img->x_size; sx<img->x_size; sx++,sj++)
      {  long txb,txe,tyb,tye;
         double xb, xe, yb, ye, dxx, dyy;
         double gsx=grid_pix_xcor(sx,grid);
         /* coordinates gsx are in grid coords no problems with orien,,, */
	      if (frame && frame[sj]==0) continue;
	      x=grid_cor_xpos(gsx, gsy, grid);
         y=grid_cor_ypos(gsx, gsy, grid);
         dxx=grid_cor_dx(gsx, gsy, grid, grid->xcor);
         dyy=grid_cor_dy(gsx, gsy, grid, grid->ycor);
         surf=grid_cor_surf(gsx, gsy, grid);
         txb=xb=x-dxx/2;
         txe=xe=x+dxx/2;
         tyb=yb=y-dyy/2;
         tye=ye=y+dyy/2;
         for (tx=txb; tx<=txe;tx++)
         {  double dx;
            if(tx<0 || tx>=img->x_size) continue;
            if (xb < tx )
            {  if ( xe < tx )        continue;
               dx = ( xe <= tx+1 ) ? xe-tx : 1;
               }
            else if ( xb > tx+1 )   continue;
            else dx = ( xe <= tx+1 ) ? xe-xb : tx+1-xb;
            for (ty=tyb; ty<=tye;ty++)
            {  double dy;
               if(ty<0 || ty>=img->y_size) continue;
               if (yb < ty )
               {  if ( ye < ty )        continue;
                  dy = ( ye <= ty+1 ) ? ye-ty : 1;
                  }
               else if ( yb > ty+1 )   continue;
               else dy = ( ye <= ty+1 ) ? ye-yb : ty+1-yb;
               tj = ty*img->x_size+tx;
               s = dx*dy/surf;
               value[tj] += s * i_value[sj];
               surface[tj] += s*surf;
               if ( grid_frame ) grid_frame[tj]++;
            }  } /*for  tx, ty*/ 
      } }  /*for  sx, sy*/ 
   if ( grid_mode && strstr(grid_mode,"FLAT") )
   {  if ( grid_mode && strstr(grid_mode,"STRICT") )
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]) i_value[sj]=value[sj]/surface[sj];
         else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]) ? 1 : 0;
         }
      else   
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]>=0.5) i_value[sj]=value[sj]/surface[sj];
           else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]>=0.5) ? 1 : 0;
         }
      }
   else
   {  if ( grid_mode && strstr(grid_mode,"STRICT") )
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]) i_value[sj]=value[sj];
           else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]) ? 1 : 0;
         }
      else   
      {  tj = 0;
         for (sj=0; sj<img->size; sj++) 
           if (surface[sj]>=1.0) i_value[sj]=value[sj];
           else  if ( surface[sj]>0.5) 
           {   i_value[sj]=value[sj]/surface[sj];
               tj++;
               }   
           else i_value[sj]=0;
          if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]<0.5) ? 0 : 1;
         printf ("# %d pixels corrected for border effects\n", tj);
         }
      }
   free(value);
   free(surface);
   if (img->frame) free(img->frame);
   img->frame=grid_frame;
   }
/*-----------------------------------------------------------*/
void grid_cor_img ( GRID_COR *grid, IMAGE *img, int scale )
{  float  *surface;
   double *value;
   long sx,sy,sj;
   long tx,ty,tj;
   double x,xx,y,yy,v;
   FLOAT64 *i_value = xy_needsfloat(img);
   FRAMES *frame = img->frame;
   FRAMES *grid_frame;
   long tab[50],itab=0;
   GRID_INTERNAL *internal=grid->internal;
   printf ("\n#%s:grid_cor_img  '%s' size=%d(%dx%d)\n", __FILE__, img->name, 
            img->size,img->x_size,img->y_size);
   if (grid->size==0 || grid->valid && 3 != 3)
      v_error(__FILE__, "grid functions are not valid (look at .ini file)");
   if (grid->valid == 3) grid_square_onccd(grid);
   surface = (float *) prg_alloc(__FILE__, "surface", img->size * sizeof(float), 1);
   value = (FLOAT64 *) prg_alloc(__FILE__, "corrected values", img->size * sizeof(double), 1);
   if ( ! i_value ) v_error(__FILE__, "no data in %s", img->name);
   grid_frame = (FRAMES *) prg_alloc(__FILE__, "frame", img->size * sizeof(FRAMES), 1);
   if (!grid_frame )
     if ( grid_mode && !strstr(grid_mode,"STRICT") ) 
           printf(" unable to alloc frame for grid correction and GRID_MODE not STRICT\n");
     else grid_mode="STRICT";
   if ( ! internal->xy_pos.valid==1 ) grid_xycalc(grid, img->x_size, img->y_size);
   for (sy=0; sy<img->y_size; sy++)
   {  for (sx=0,sj=sy*img->x_size; sx<img->x_size; sx++,sj++)
      {  long  txb,txe,tyb,tye;
         float xb, xe, yb, ye, dxx, dyy;
	      float s, surf;
         if (frame && frame[sj]==0) continue;
         x=internal->xy_pos.xcor[sj];
         y=internal->xy_pos.ycor[sj];
         dxx=internal->xy_pos.dxx[sj];
         dyy=internal->xy_pos.dyy[sj];
         surf=internal->xy_pos.surf[sj];
         txb=xb=x-dxx/2;
         txe=xe=x+dxx/2;
         tyb=yb=y-dyy/2;
         tye=ye=y+dyy/2;
         for (tx=txb; tx<=txe;tx++)
         {  float dx;
            if(tx<0 || tx>=img->x_size) continue;
            if (xb < tx )
            {  if ( xe < tx )        continue;
               dx = ( xe <= tx+1 ) ? xe-tx : 1;
               }
            else if ( xb > tx+1 )   continue;
            else dx = ( xe <= tx+1 ) ? xe-xb : tx+1-xb;
            for (ty=tyb; ty<=tye;ty++)
            {  float dy;
               if(ty<0 || ty>=img->y_size) continue;
               if (yb < ty )
               {  if ( ye < ty )        continue;
                  dy = ( ye <= ty+1 ) ? ye-ty : 1;
                  }
               else if ( yb > ty+1 )   continue;
               else dy = ( ye <= ty+1 ) ? ye-yb : ty+1-yb;
               tj = ty*img->x_size+tx;
               s = dx*dy/surf;
               value[tj] += s * i_value[sj];
               surface[tj] += s*surf;
               if ( grid_frame ) grid_frame[tj]++;
            }  } /*for  tx, ty*/ 
      } }  /*for  sx, sy*/ 
   if ( grid_mode && strstr(grid_mode,"FLAT") )
   {  if ( grid_mode && strstr(grid_mode,"STRICT") )
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]) i_value[sj]=value[sj]/surface[sj];
         else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]) ? 1 : 0;
         }
      else   
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]>=0.5) i_value[sj]=value[sj]/surface[sj];
           else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]>=0.5) ? 1 : 0;
         }
      }
   else
   {  if ( grid_mode && strstr(grid_mode,"STRICT") )
      {  for (sj=0; sj<img->size; sj++) 
           if (surface[sj]) i_value[sj]=value[sj];
           else i_value[sj] = 0;
         if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]) ? 1 : 0;
         }
      else   
      {  tj = 0;
         for (sj=0; sj<img->size; sj++) 
           if (surface[sj]>=1.0) i_value[sj]=value[sj];
           else  if ( surface[sj]>0.5) 
           {   i_value[sj]=value[sj]/surface[sj];
               tj++;
               }   
           else i_value[sj]=0;
          if (grid_frame) for (sj=0; sj<img->size; sj++) 
             grid_frame[sj] = (surface[sj]<0.5) ? 0 : 1;
         printf ("# %d pixels corrected for border effects\n", tj);
         }
      }
   free(value);
   free(surface);
   if (img->frame) free(img->frame);
   img->frame=grid_frame;
   }
/*-----------------------------------------------------------*/
char * coef_grid_name(int i)
{  static char model[9];
   int x,y;
   grid_deg_xy(i,&x,&y,0);
   sprintf (model,"x^%dy^%d", x, y);
   return model;
   } 
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
void grid_pix_surf_ini(int x_size, int y_size, GRID_COR *grid)
{  GRID_INTERNAL *internal=grid->internal;
   if ( ! internal->xy_pos.valid==1 ) grid_xycalc(grid, x_size, y_size);
   }
/*-----------------------------------------------------------*/
double grid_pix_surf(int sj, GRID_COR *grid)
{  GRID_INTERNAL *internal=grid->internal;
   if (! internal->xy_pos.valid==1 ) v_error(__FILE__, " : grid_pix_surf not initialised\n");
   return internal->xy_pos.surf[sj];
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
double grid_pix_xcor(double x, GRID_COR *grid)
{  double rx;
   if (grid_xbind>0) rx=x*grid_xbind+grid_xmin-grid->xcor[0];
   else     rx=x*grid_xbind-grid_xmin+grid->xcor[0];
   return rx;
   }
/*-----------------------------------------------------------*/
double grid_pix_ycor(double y, GRID_COR *grid)
{  double ry;
   if (grid_ybind>0) ry=y*grid_ybind+grid_ymin-grid->ycor[0];
   else     ry=y*grid_ybind-grid_ymin+grid->ycor[0];
   return ry;
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
static xdbg=0;
static ydbg=0;
/*-----------------------------------------------------------*/
double grid_cor_xpos(double x, double y, GRID_COR *grid)
{  double res, rx;
   int j;
   GRID_INTERNAL *internal=grid->internal;
   res = 0;
   grid_tabulate_pixel(x, y, grid);
   for (j=0; j<grid->size;j++) res+= grid->xcor[j]*internal->tabulated.value[j];
   if (grid_xbind>0) rx=(res-grid_xmin)/grid_xbind;
   else     rx=(res+grid_xmin-2*grid->xcor[0])/grid_xbind;

/*   if (xdbg++ % 100==0) printf (" x %lf y %lf    res %lf--> X %lf\n",x,y, res,rx);*/
   return rx;
   }
/*-----------------------------------------------------------*/
double grid_cor_ypos(double x, double y, GRID_COR *grid)
{  double res,ry;
   int j;
   GRID_INTERNAL *internal=grid->internal;
   res = 0;
   grid_tabulate_pixel(x, y, grid);
   for (j=0; j<grid->size;j++) res+= grid->ycor[j]*internal->tabulated.value[j];
   if (grid_ybind>0) ry=(res-grid_ymin)/grid_ybind;
   else     ry=(res+grid_ymin-2*grid->ycor[0])/grid_ybind;
/*   if (ydbg++ % 100==0) printf (" x %lf y %lf    res %lf--> Y %lf\n",x,y, res,ry);*/
   return ry;
   }
/*-----------------------------------------------------------*/
double grid_cor_surf(double px, double py, GRID_COR *grid)
{  double dxx, dyy;
   dxx=grid_cor_dx(px, py, grid, grid->xcor);
   dyy=grid_cor_dy(px, py, grid, grid->ycor);
   return grid_cor_surf_diag(px, py, grid, dxx*dyy);
   }
/*-----------------------------------------------------------*/
static double grid_cor_surf_diag(double px, double py, GRID_COR *grid, double dxx_yy)
{  double dxy, dyx;
   dxy=grid_cor_dy(px, py, grid, grid->xcor);
   dyx=grid_cor_dx(px, py, grid, grid->ycor);
   return dxx_yy-dxy*dyx;
   }
/*-----------------------------------------------------------*/
double grid_cor_der (int i, double x, double y, GRID_COR *grid)
{  GRID_INTERNAL *internal=grid->internal;
   grid_tabulate_pixel(x, y, grid);
   return internal->tabulated.value[i];
   }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
static int grid_deg_xy (int i, int *x, int *y,int retcode)
{  int n=1;
   int p=1;
   while (i >= p) p+=++n;
   p-=n--;
   *y=i-p;
   *x=n-*y;
   if (retcode == 0) return n;   /* x+y degree */
   /* x(1) , y (2) derivative xy position */
   if (retcode == 1) 
   {  if (*x) return i-n; else return -1; }
   if (retcode == 2) 
   {  if (*y) return i-n-1; else return -1; }
   }
/*-----------------------------------------------------------*/
static double grid_cor_dx(double x, double y, GRID_COR *grid, double *cor)
{  double res;
   int j;
   GRID_INTERNAL *internal=grid->internal;
   res = 0;
   grid_tabulate_pixel(x, y, grid);
   for (j=0; j<grid->size;j++)
   {  int i,dx, dy;
      i=grid_deg_xy(j,&dx,&dy,1);
      if ( i>=0) res+=cor[j]*dx*internal->tabulated.value[i];
      }
   return res;
   }
/*-----------------------------------------------------------*/
static double grid_cor_dy(double x, double y, GRID_COR *grid, double *cor)
{  double res;
   int j;
   GRID_INTERNAL *internal=grid->internal;
   res = 0;
   grid_tabulate_pixel(x, y, grid);
   for (j=0; j<grid->size;j++)
   {  int i,dx, dy;
      i=grid_deg_xy(j,&dx,&dy,2);
      if ( i>=0) res+=cor[j]*dy*internal->tabulated.value[i];
      }
   return res;
   }
/*-----------------------------------------------------------*/
/* the usage of tabulated values reduces strongly the time due to pow call */
/*-----------------------------------------------------------*/
static void grid_tabulate_pixel(double x, double y, GRID_COR *grid)
{  int j;
   GRID_INTERNAL *internal=grid->internal;
   if( x==internal->tabulated.gsx && y==internal->tabulated.gsy && internal->tabulated.ok==1) return;
   for (j=0; j<grid->size;j++) 
   {  int dx, dy;
      grid_deg_xy(j,&dx,&dy,0);
      internal->tabulated.value[j]=pow(x,dx)*pow(y,dy);
      }
    internal->tabulated.gsx=x;
    internal->tabulated.gsy=y;
    internal->tabulated.ok=1;
    }
/*-----------------------------------------------------------*/
/* the bm2grid assume a perfect square grid, but  ......     */
/*-----------------------------------------------------------*/
static void grid_square_onccd(GRID_COR *grid)
{  int j;
   if (grid->size==0 || grid->valid != 3)
      v_error(__FILE__, "grid is not in valid state for squaring (report please)");
   if (grid_xy_ratio == 0 || grid_xy_ratio == -1)
   {  printf(" no squaring on ccd allowed for grid_xy_ratio == 0, -1\n");
      grid->valid |= 4;
      return;
      }
   if (grid_xy_ratio > 0)
   {  printf(" using given square ratio for ccd (%.4f)\n", grid_xy_ratio);
      grid_cor_aniso(grid_xy_ratio, grid);
      grid->valid |= 4;
      return;
      }
    v_error(__FILE__, "unvalid xy_ratio parameter : %.4f < 0\n", grid_xy_ratio);
    }
/*-----------------------------------------------------------*/
void grid_cor_aniso(double ratio, GRID_COR *grid)
{   int i;
    for (i=0;i<grid->size;i++)
       grid->ycor[i] *=ratio;
    }
/*-----------------------------------------------------------*/
void   grid_cor_product(GRID_COR *grid, GRID_COR *grid2)
{   int i;
    for (i=0;i<grid->size;i++)
       grid->ycor[i] *=1;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
static void   grid_xycalc(GRID_COR *grid, int xsize, int ysize)
{  int sx, sy, sj;
   float **mem_gsx;
   float **mem_gsy;
   GRID_INTERNAL *internal=grid->internal;
   int i,max_deg;
/*   {   int valid;
/*       int xsize, xmin, xbind;
/*       int ysize, ymin, ybind;
/*       float *xcor, *ycor; 
/*       float *dxx, *dyy, *surf; 
/*       } xy_pos;  */
   if (internal->xy_pos.xcor) free (internal->xy_pos.xcor);
   if (internal->xy_pos.ycor) free (internal->xy_pos.ycor);
   internal->xy_pos.valid=0;
   internal->xy_pos.size=xsize*ysize;
   internal->xy_pos.xsize=xsize;
   internal->xy_pos.xmin=grid_xmin;
   internal->xy_pos.xbind=grid_xbind;
   internal->xy_pos.ysize=ysize;
   internal->xy_pos.ymin=grid_ymin;
   internal->xy_pos.ybind=grid_ybind;
   internal->xy_pos.xcor =(float *) prg_alloc (__FILE__, "grid_xycalc xcor",xsize*ysize*sizeof(float),1);
   internal->xy_pos.ycor =(float *) prg_alloc (__FILE__, "grid_xycalc ycor",xsize*ysize*sizeof(float),1);
   internal->xy_pos.dxx =(float *) prg_alloc (__FILE__, "grid_xycalc dxx",xsize*ysize*sizeof(float),1);
   internal->xy_pos.dyy =(float *) prg_alloc (__FILE__, "grid_xycalc dyy",xsize*ysize*sizeof(float),1);
   internal->xy_pos.surf =(float *) prg_alloc (__FILE__, "grid_xycalc surf",xsize*ysize*sizeof(float),1);
   /* the usage of fully tabulated values reduces strongly the time due to pow call */
   grid_deg_xy(grid->size-1,&i,&max_deg,0);
   max_deg+=1;
   mem_gsx=(float **) prg_alloc (__FILE__, "grid_xycalc gsx", max_deg*sizeof(float *),1);
   for (i=0;i<max_deg;i++)  mem_gsx[i]=(float *) prg_alloc (__FILE__, "grid_xycalc gsx", xsize*sizeof(float),1);
   mem_gsy=(float **) prg_alloc (__FILE__, "grid_xycalc gsy", max_deg*sizeof(float *),1);
   for (i=0;i<max_deg;i++)  mem_gsy[i]=(float *) prg_alloc (__FILE__, "grid_xycalc gsy",ysize*sizeof(float),1);
   /* storing power of each coords */
   for (sx=0; sx<xsize; sx++) 
   {   float gsx, gsxi;
       mem_gsx[0][sx]=gsxi=1.0;    
       gsx=grid_pix_xcor(sx,grid);    
       for (i=1;i<max_deg;i++) mem_gsx[i][sx]=gsxi*=gsx;
       }
   for (sy=0; sy<ysize; sy++) 
   {   float gsy, gsyi;
       mem_gsy[0][sy]=gsyi=1.0;    
       gsy=grid_pix_ycor(sy,grid);    
       for (i=1;i<max_deg;i++) mem_gsy[i][sy]=gsyi*=gsy;
       }
   /* coordinates gsx are in grid coords no problems with orien,,, */
   for (sy=0; sy<ysize; sy++)
   {  for (sx=0,sj=sy*xsize; sx<xsize; sx++,sj++)
      {  int j;
         double rx, ry;
         double dxx, dyy, dyx, dxy;
/*         float ox, oy;
         double gsy=grid_pix_ycor(sy,grid);
         double gsx=grid_pix_xcor(sx,grid);
	      ox=grid_cor_xpos(gsx, gsy, grid);
         oy=grid_cor_ypos(gsx, gsy, grid);*/ 
         dxx=dyy=dyx=dxy=rx = ry = 0;
         for (j=0; j<grid->size;j++) 
         {  int dx,dy;
            double t;
            grid_deg_xy(j,&dx,&dy,0);
            t=mem_gsx[dx][sx]*mem_gsy[dy][sy];
            rx+=grid->xcor[j]*t;
            ry+=grid->ycor[j]*t;
            }
	      if (grid_xbind>0) internal->xy_pos.xcor[sj]=(rx-grid_xmin)/grid_xbind;
         else              internal->xy_pos.xcor[sj]=(rx+grid_xmin-2*grid->xcor[0])/grid_xbind;
	      if (grid_ybind>0) internal->xy_pos.ycor[sj]=(ry-grid_ymin)/grid_ybind;
         else              internal->xy_pos.ycor[sj]=(ry+grid_ymin-2*grid->ycor[0])/grid_ybind;
         for (j=0; j<grid->size;j++) 
         {  int dx,dy;
            if (grid_deg_xy(j,&dx,&dy,1) >= 0)
            {  dxx+=dx*grid->xcor[j]*mem_gsx[dx-1][sx]*mem_gsy[dy][sy];
               dyx+=dx*grid->ycor[j]*mem_gsx[dx-1][sx]*mem_gsy[dy][sy];
            }  }
         for (j=0; j<grid->size;j++) 
         {  int dx,dy;
            if (grid_deg_xy(j,&dx,&dy,2) >= 0)
            {  dyy+=dy*grid->ycor[j]*mem_gsx[dx][sx]*mem_gsy[dy-1][sy];
               dxy+=dy*grid->xcor[j]*mem_gsx[dx][sx]*mem_gsy[dy-1][sy];
            }  }
         internal->xy_pos.dxx[sj]=dxx;
         internal->xy_pos.dyy[sj]=dyy;
         internal->xy_pos.surf[sj]=dxx*dyy-dyx*dxy;
      }  }  /*for  sx, sy*/ 
   for (i=0;i<max_deg;i++)
   {  free(mem_gsy[i]);
      free(mem_gsx[i]);
      }
   free (mem_gsy);
   free (mem_gsx);
/*    for (sy=0; sy<ysize; sy++)
   {  for (sx=0,sj=sy*xsize; sx<xsize; sx++,sj++)
      {  float dxx,dyy,dxy,dyx;
/*         if (sy > 0) dyy=internal->xy_pos.ycor[sj]-internal->xy_pos.ycor[sj-xsize];
         else        dyy=internal->xy_pos.ycor[sj+xsize]-internal->xy_pos.ycor[sj];
         if (sx > 0 ) dyx=internal->xy_pos.ycor[sj]-internal->xy_pos.ycor[sj-1];
         else        dyx=internal->xy_pos.ycor[sj+1]-internal->xy_pos.ycor[sj];
         if (sy > 0 ) dxy=internal->xy_pos.xcor[sj]-internal->xy_pos.xcor[sj-xsize];
         else        dxy=internal->xy_pos.xcor[sj+xsize]-internal->xy_pos.xcor[sj];
         internal->xy_pos.dxx[sj]=dxx;
         internal->xy_pos.dyy[sj]=dyy;
         internal->xy_pos.surf[sj]=dxx*dyy-dxy*dyx;
*/   /*   }  }  /*for  sx, sy*/ 
   internal->xy_pos.valid=1;
   }
/*-----------------------------------------------------------*/
