static char *cvs_id =" $Id: xy_transfo.c,v 1.4 2004/09/23 06:35:27 berar Exp $ ";
/*  xy_hdr : image transformation (sqrt ....         */
/*  jfberar   berar@esrf.fr                          */
/*  ------------------------------------------------ */
/*  22 Mar 02 : eval parser for more transfo, jfb    */
/*  12 Jun 01 : sqrt     needed by jps               */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
/* #include "prg_def.h"
*/
#include "xy_def.h" 
char  *str_time;
typedef enum {OPER_NONE, OPER_L_NOT, OPER_L_AND, OPER_L_OR, 
   OPER_N_EQ, OPER_N_NE, OPER_N_GT, OPER_N_GE, OPER_N_LT, OPER_N_LE,
	OPER_N_ADD, OPER_N_SUB, OPER_N_MUL, OPER_N_DIV, OPER_N_MOD, OPER_N_POW, 
	OPER_N_NEG, OPER_P_X, OPER_P_Y, OPER_P_Z, OPER_P_NUM, OPER_P_FLOAT, 
   OPER_P_PIX, OPER_N_LOG, OPER_N_EXP, OPER_N_ABS, OPER_N_SQRT } TYPE_OP;
typedef struct
{  TYPE_OP op;
   struct
   {  void * ptr;
      double val;
      } left;
	void * right;
   } TYPE_RULE;
typedef TYPE_RULE * TYPE_RULE_PTR;
static int    int_evaluate(TYPE_RULE_PTR rule);
static double rule_evaluate(TYPE_RULE_PTR rule);
static TYPE_RULE_PTR rule_analyse( char * string);
void  transfo_image( char *name, IMAGE *img);
/*-----------------------------------------------------------*/
/*int main ( int argc, char ** argv )
{   char name[200];
    image.data = (long *) malloc (10*10*sizeof(int));
    image.x_size=image.y_size=10;
    while (--argc)
    {  argv++;
       transfo_image( *argv, &image);
       }
    }   
/*-----------------------------------------------------------*/
void  transfo_image( char *name, IMAGE *img)
{   XY_COUNTS *v =&img->data;
    double d;
    int ix, iy;
    char *c;
    TYPE_RULE *rule;
    if (img->data.i == NULL && img->data.f == NULL) V_ERROR("no data to process");
    if (name[0]=='=' ) name++;
    if (name[0]=='"' ) 
    {   name++;
        c=strchr(name,'"');
        if (c) *c=0;
        }
    if (name[0]=='\'' ) 
    {   name++;
        c=strchr(name,'\'');
        if (c) *c=0;
        }
	 printf("\n-------------- name='%s'\n",name);
    rule = rule_analyse(name);
    fprintf( stderr, "name '%s' rule %d\n", name, rule->op);
    for ( iy=0; iy < img->y_size; iy++) 
      for ( ix=0; ix < img->x_size; ix++) 
	   {  int j = iy * img->x_size + ix;
/*		   double w = v[j];
/*         rule_evaluate(ix,iy,v);*/
		   }
   }
/*-----------------------------------------------------------*/
static TYPE_RULE_PTR axe_rule[2];
static double eval_x, eval_y;
/*-----------------------------------------------------------*/
void ini_transfo_coord( char *name, int axe)
{  TYPE_RULE *rule;
   char *c;
   if (axe <0 || axe >=4) 
   {   V_ERROR("invalid axe reference in ini_transfo_coord");
       }
   if (name[0]=='=' ) name++;
    if (name[0]=='"' ) 
    {   name++;
        c=strchr(name,'"');
        if (c) *c=0;
        }
    if (name[0]=='\'' ) 
    {   name++;
        c=strchr(name,'\'');
        if (c) *c=0;
        }
/*	 printf("\n axe %c  name='%s'\n",'X'+axe, name);*/
    axe_rule[axe]=rule_analyse(name);
}
/*-----------------------------------------------------------*/
void end_transfo_coord()
{
   }
/*-----------------------------------------------------------*/
double transfo_coord( int axe, double x, double y)
{  double eval;
   eval_x = x;
   eval_y = y;
   eval = rule_evaluate(axe_rule[axe]);
/*   fprintf (stderr, " %c (%lf,%lf)  eval %lf\n", 'X'+axe, eval_x, eval_y, eval);*/
   return eval;
   }
/*-----------------------------------------------------------*/
double density_coord( int axe, double x, double y)
{  eval_x = x;
   eval_y = y;
   return rule_evaluate(axe_rule[axe]);
   }
/*-----------------------------------------------------------*/
/* ---------------------------------------------- */
/* images transformation according to             */
/* T=n      each pixel is set to numerical n      */
/* T=l?n:m  pixels with logic l true are set to n */
/* T=n:l,.. pixels with logic l true are set to n */
/* logical  l :                                   */
/*    (l), l && l, l || l, !l, l_prim             */
/* l_prim :                                       */
/*   x == n, x != n, x > n, x >= n, x < n, x <= n */
/*   y == n, y != n, x > n, x >= n, x < n, x <= n */
/*   z == n, z != n, x > n, x >= n, x < n, x <= n */
/* numerical n:                                   */
/*    (n), n + n, n - n, n * n, n / n , n ^ n     */
/*     n,  n_prim                                 */
/* n_prim :                                       */
/*    n_func(n)                                   */
/*    x, y   : pixel position                     */
/*    z pixel value                               */
/*    ln , log, abs, sqrt, exp(n) numerical funct */
/*    Z(n,n)  : pixel value  (z=Z(x,y))           */
/*    decimal or float                            */
/* ---------------------------------------------- */
static int    syntax_error = 0;
static int    current_error;
static char * current_string;
/* --------------------------------------------- */
/* ------------------------------------------------------------------ */
/*  following are static internal procedures     */
/* --------------------------------------------- */
static int analyse_error( char * m, char * l);
static int is_enclosed (char * string);
static int get_prim (char * string, TYPE_RULE *rule);
static int get_operf (char * string, TYPE_RULE *rule, TYPE_OP op_type, char *op_string);
static int get_oper1 (char * string, TYPE_RULE *rule, TYPE_OP op_type, char *op_string);
static int get_oper2 (char * string, TYPE_RULE *rule, TYPE_OP op_type, char *op_string);
/* --------------------------------------------- */
char * rule_name[] =
   { "OPER_NONE", "OPER_L_NOT", "OPER_L_AND", "OPER_L_OR", 
   "OPER_N_EQ", "OPER_N_NE", "OPER_N_GT", "OPER_N_GE", "OPER_N_LT", "OPER_N_LE",
	"OPER_N_ADD", "OPER_N_SUB", "OPER_N_MUL", "OPER_N_DIV", "OPER_N_MOD", "OPER_N_POW", 
	"OPER_N_NEG", "OPER_P_X", "OPER_P_Y", "OPER_P_Z", "OPER_P_NUM", 
   "OPER_P_FLOAT", "OPER_P_PIX", "OPER_N_LOG", "OPER_N_EXP", "OPER_N_ABS", "OPER_N_SQRT"};
/* --------------------------------------------- */
static TYPE_RULE * rule_analyse( char * string )
{  TYPE_RULE * rule;
   char *copy, *a;
   current_string = string;
   rule = (TYPE_RULE *) malloc(sizeof(TYPE_RULE));
   rule->op = OPER_NONE;
   a = copy = malloc(1+strlen(string));
   strcpy (copy, string);
   while ( *a && (is_enclosed(a) || *a == ' ')) a++;
   if ( ! get_oper2( a, rule, OPER_L_OR,  "||") )
   if ( ! get_oper2( a, rule, OPER_L_OR,  "|" ) )
   if ( ! get_oper2( a, rule, OPER_L_AND, "&&") )
   if ( ! get_oper2( a, rule, OPER_L_AND, "&" ) )

   if ( ! get_oper2( a, rule, OPER_N_GE,  ">=") )
   if ( ! get_oper2( a, rule, OPER_N_LE,  "<=") )
   if ( ! get_oper2( a, rule, OPER_N_NE,  "!=") )
   if ( ! get_oper2( a, rule, OPER_N_EQ,  "==") )
   if ( ! get_oper2( a, rule, OPER_N_EQ,  "=" ) )
   if ( ! get_oper2( a, rule, OPER_N_GT,  ">") )
   if ( ! get_oper2( a, rule, OPER_N_LT,  "<") )

   if ( ! get_oper1( a, rule, OPER_L_NOT, "!" ) )

   if ( ! get_oper2( a, rule, OPER_N_ADD, "+" ) )
   if ( ! get_oper2( a, rule, OPER_N_SUB, "-" ) )
   if ( ! get_oper2( a, rule, OPER_N_MUL, "*" ) )
   if ( ! get_oper2( a, rule, OPER_N_DIV, "/" ) )
   if ( ! get_oper2( a, rule, OPER_N_POW, "^" ) )

   if ( ! get_oper1( a, rule, OPER_N_NEG, "-" ) )
   
   if ( ! get_operf( a, rule, OPER_N_LOG, "LOG" ) )
   if ( ! get_operf( a, rule, OPER_N_EXP, "EXP" ) )
   if ( ! get_operf( a, rule, OPER_N_ABS, "ABS" ) )
   if ( ! get_operf( a, rule, OPER_N_SQRT, "SQRT" ) )
   if ( ! get_prim ( a, rule ) )
       analyse_error("unresolved sentence ", a);
   free(copy);
   return rule;
   }
/* --------------------------------------------- */
static double rule_evaluate(TYPE_RULE_PTR rule)
{  double eval;
	switch (rule->op)
   {  case OPER_L_NOT : 
	       eval = ! rule_evaluate(rule->left.ptr);  break;
      case OPER_L_AND : 
		    eval = rule_evaluate(rule->left.ptr) && rule_evaluate(rule->right); break;
      case OPER_L_OR  : 
		    eval = rule_evaluate(rule->left.ptr) || rule_evaluate(rule->right); break;
      case OPER_N_EQ  : 
		    eval = rule_evaluate(rule->left.ptr) == rule_evaluate(rule->right); break;
      case OPER_N_NE  : 
		    eval = rule_evaluate(rule->left.ptr) != rule_evaluate(rule->right); break;
      case OPER_N_GT  : 
		    eval = rule_evaluate(rule->left.ptr) >  rule_evaluate(rule->right); break;
      case OPER_N_GE  : 
		    eval = rule_evaluate(rule->left.ptr) >= rule_evaluate(rule->right); break;
      case OPER_N_LT  : 
		    eval = rule_evaluate(rule->left.ptr) <  rule_evaluate(rule->right); break;
      case OPER_N_NEG : 
		    eval = - rule_evaluate(rule->left.ptr);   break;
      case OPER_N_ADD : 
		    eval = rule_evaluate(rule->left.ptr) + rule_evaluate(rule->right); break;
      case OPER_N_SUB : 
		    eval = rule_evaluate(rule->left.ptr) - rule_evaluate(rule->right); break;
      case OPER_N_MUL : 
		    eval = rule_evaluate(rule->left.ptr) * rule_evaluate(rule->right); break;
      case OPER_N_DIV : 
		    eval = rule_evaluate(rule->left.ptr) / rule_evaluate(rule->right); break;
      case OPER_N_POW: 
		    eval = pow(rule_evaluate(rule->left.ptr),rule_evaluate(rule->right)); break;
      case OPER_N_LOG: 
		    eval = log(rule_evaluate(rule->left.ptr)); break;
      case OPER_N_EXP: 
		    eval = exp(rule_evaluate(rule->left.ptr)); break;
      case OPER_N_ABS: 
		    eval = fabs(rule_evaluate(rule->left.ptr)); break;
      case OPER_N_SQRT: 
		    eval = sqrt(rule_evaluate(rule->left.ptr)); break;
      case OPER_P_X : 
		   eval = eval_x ;  break;
      case OPER_P_Y : 
		   eval = eval_y ;  break;
      case OPER_P_NUM : 
		   eval =  rule->left.val ;         break;
      case OPER_P_FLOAT : 
		   eval =  rule->left.val ;         break;
      default : ;
      }
   return eval;

   }
/* --------------------------------------------- */
/* --------------------------------------------- */
static int analyse_error( char * m, char * l)
{  fprintf( stderr, "syntax error in '%s' : %s '%s'\n", current_string, m, l);
   syntax_error++;
   current_error++;
   return 0;
   }
/* --------------------------------------------- */
/* --------------------------------------------- */
static int is_enclosed (char * string)
{  char *a = string;
   int n= 0, level = 0;
   if (current_error) return 0;
   while (*a)
   {  switch (*a)
      {  case '(' : level++; break;
         case ')' : level--; break;
         }
      if (level == 0 ) n++;
      a++;
      }
   if (level != 0)  return analyse_error( "is_enclosed, unbalanced parenthesis in", string);
   if ( string[0] != '(' || n > 1) return 0;
   a--;
   *a=0;
   return 1;  
   }
/* --------------------------------------------- */
static int get_prim (char * string, TYPE_RULE *rule)
{  char *a = string;
   int  w, v, n;
   double d;
   if (current_error) return -1;
   while (*a == ' ' ) a++ ;
   if ( *a == 'x' )
   {   rule->op = OPER_P_X;
       rule->left.val = 0;
       a++;
       }
   else if ( *a == 'y' )
   {   rule->op = OPER_P_Y;
       rule->left.val = 0;
       a++;
       }
   else if ( *a == 'z' )
   {   rule->op = OPER_P_Z;
       rule->left.val = 0;
       a++;
       }
   else if ( *a >= 'Z' )
   {   rule->op = OPER_P_PIX;
       rule->left.val = *a - 'K'+ 1;
       a++;
       }
   else if ( sscanf(a, "%lg%n", &d, &w) == 1)
   {   rule->op = OPER_P_FLOAT;
       rule->left.val = d;
       sscanf(a, "%d%n", &n, &v);
       if ( v==w)
       {  rule->op = OPER_P_NUM;
          rule->left.val = n;
          }
       a+=w;
       }
   else return analyse_error("unknown primitive ", a);
   while ( *a == ' ' ) a++ ;
   if ( *a ) return analyse_error("unexpected char ", a);
   return 1;
   }
/* --------------------------------------------- */
static int get_operf (char * string, TYPE_RULE *rule,
   TYPE_OP op_type, char *op_string)
{  char *a = string;
   int level = 0;
   if (current_error) return -1;
   while (*a == ' ' ) a++ ;
   if ( (strstr(a, op_string) == a) && level == 0 )
   {  a += strlen(op_string);
      if (strlen(a) == 0) return analyse_error("empty right operand of", op_string);
      if (*a != '(') return analyse_error("missing parenthesis", op_string);
      rule->op = op_type;
      rule->left.ptr  = rule_analyse (a);
      return 1;
      }
   return 0;
   }
/* --------------------------------------------- */
static int get_oper1 (char * string, TYPE_RULE *rule,
   TYPE_OP op_type, char *op_string)
{  char *a = string;
   int level = 0;
   if (current_error) return -1;
   while (*a == ' ' ) a++ ;
   if ( (strstr(a, op_string) == a) && level == 0 )
   {  a += strlen(op_string);
      if (strlen(a) == 0) return analyse_error("empty right operand of", op_string);
      rule->op = op_type;
      rule->left.ptr  = rule_analyse (a);
      return 1;
      }
   return 0;
   }
/* --------------------------------------------- */
static int get_oper2 (char * string, TYPE_RULE *rule,
   TYPE_OP op_type, char *op_string)
{  char *right, *a = string;
   int level = 0;
   if (current_error) return -1;
   while (*a)
   {  if (*a == op_string[0] )
      {   if ( (strstr(a, op_string) == a) && level == 0 )
          {  *a = 0;
             right = a + strlen(op_string);
             if (strlen(string) == 0 ) return analyse_error("empty left operand of", op_string);
             if (strlen(right) == 0) return analyse_error("empty right operand of", op_string);
             rule->op = op_type;
             rule->left.ptr  = rule_analyse (string);
             rule->right = rule_analyse (right);
             return 1;
             }
          }
      else switch (*a)
      {  case '(' : level++; break;
         case ')' : level--; break;
         }
      a++;
      }
   if (level)  return analyse_error( "get_oper2, unbalanced parenthesis", string);
   return 0;
   }
/* --------------------------------------------- */
/* --------------------------------------------- */
